/*
 *  lxdvdrip.c, abgeleitet aus lsdvd.c aus dem "vamps" bzw. "AcidRip" Paket
 *
 *  DVD Rippen&brennen
 *  
 *  lsdvd liest die Struktur einer DVD aus. Diese Informationen werden in diesem 
 *  Programm benutzt zur Auswertung des laengsten Titels, des Requantisierungsfaktors
 *  und der Audiospuren.
 *
 *  lxdvdrip -h zeigt alle Parameter an.
 *
 *  Copyright (C) 2003  EFF, Stefan Becker
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation;
 *
 *  2003	by Chris Phillips
 *  2003-04-19  Cleanups get_title_name, added dvdtime2msec, added helper macros,
 *              output info structures in form of a Perl module, by Henk Vergonet.
 *  01.01.2004: Stefan Becker, Anpassung an Trackbestimmung fuer Faktorberechnung Requantisierung.
 *              abgeleitet aus lsdvd aus dem vamps-PaketszBefe
 *  02.01.2004: Stefan Becker, Parameter "-h" listet Aufrufparameter auf
 *  03.01.2004: Stefan Becker, umgewandelt in dvdripper, ohne Umwandlung per XML
 *  17.01.2004: Stefan Becker, umgewandelt fuer "StreamDVD" statt "vamps" zum Rippen,tccat Parameter gleich
 *  18.01.2004: Stefan Becker, Aufruf StreamDVD ueber "-f" in dvdauthor eingebettet, Tmp-Pfad als Parameter entfaellt
 *  18.01.2004: Stefan Becker, Faktormethode 2 auch fuer englischen Audiotrack freischalten, F1 als Default mit Audi Tracks
 *  20.01.2004: Stefan Becker, Erweiterungen: dts als Default, da bessere Qualitaet als ac3.
 *                                            Wenn kein Track gesetzt, laengsten Track berechnen.
 *                                            VOB-Vorschau per Mplayer.
 *                                            growisofs zum Brennen starten.
 *                                            alternativ brennen mit cdrecord-prodvd.
 *  21.01.2004: Stefan Becker, Erweiterungen: Parameterdatei /etc/lxdvdrip.conf.
 *                                            Kommandozeilen-Parameter: Reihenfolge beleibig, per "-par=wert".
 *                                            Bei 2 ac3 Spuren den mit groesster Kanalzahl waehlen.
 *  21.01.2004: Stefan Becker, --help zeigt Hilfe an, Umlaute entfernt, Faktor < 1 auf 1 setzen,
 *                             wahlweise deutsche oder englische Texte fuer Ausgaben und Hilfe.
 *                             ac3-Default-Audio-Track Format waehlen.
 *                             Statt Faktormethode jetzt einen echten Faktor angeben, ohne Angabe wird Faktor berechnet.
 *  22.01.2004: Stefan Becker, Projekt umbenannt in lxdvdrip
 *                             Bitrate AC3 jetzt 384, DTS=768
 *  23.01.2004: Stefan Becker, Parameter Audio Default, Inhalt rippen nach dvdauthor anzeigen.
 *                             Rippen auch per tccat / vamps
 *  24.01.2004: Stefan Becker, Warten aufs Einlegen des Rohlings abschaltbar. Wiederholung Brennen bei Fehlschlag.
 *                             Faktor durch vamps-Testtip berechnen (-f=-1)
 *                             Mehrere Kapitel testrippen, wenn eines fehlschlaegt.
 *                             Traditionelle mplayer Methode zum Rippen (-st=mplayer)
 *                             Paramter -tmp=... fuer TEMP-Dateien bei Mplayer-Rip.
 *  25.01.2004: Stefan Becker, Dateien am Ende loeschen (-d=1).
 *                             mplex alternativ zu tcmplex einbinden (-mp=mplex).
 *                             Mitte Hilfstext Enter fuer Seite 2 druecken.
 *                             Mit "-a=4,xy" andere Sprache fuer Audiotrack als deutsch und englisch
 *  26.01.2004: Stefan Becker, Bei vamps zur Faktorberechnung Videogroesse neu setzen, bei Faktor < 1 1 als min (0.21)
 *  27.01.2004: Stefan Becker, Compiler Warnings fixed, Filegroesse mit "stat" berechnen.
 *  28.01.2004: Stefan Becker, Debuglevel, um Meldungen zu unterdruecken
 *  31.01.2004: Stefan Becker, auch transcode als streamtool (-st=transcode) (0.30)
 *  31.01.2004: Stefan Becker, Parameterdatei jetzt mit Kommentaren (0.31)
 *  31.01.2004: Stefan Becker, Version mit "-v" ausgeben (0.32)
 *  01.02.2004: Stefan Becker, Auch das Filmverzeichnis loeschen (0.33)
 *  03.02.2004: Stefan Becker, Bei mplayer-Rip DVD-Device richtig setzen (0.34)
 *  06.02.2004, Stefan Becker, freien Festplattenplatz berechnen (0.35)
 *  08.02.2004, Stefan Becker, Chapter-Struktur an DVD-Author uebergeben (0.40)
 *  08.02.2004, Stefan Becker, Bei mplayer / transcode und Faktor 1 kein tcrequant (0.41)
 *  09.02.2004, Stefan Becker, Bei growisofs/mkisofs Volume-Label setzen laut Titel der DVD.
 *                             Mit Parameter "-lab=" kann Titel gesetzt werden von aussen.
 *  09.02.2004, Stefan Becker, Chapter Unterteilung abschaltbar (-chap=0)
 *  09.02.2004, Stefan Becker, Bei ac3/2 Kanal Bitrate auf 128 statt 244 gesetzt (0.42)
 *                             2 % auf Faktor als Sicherheit aufschlagen
 *  10.02.2004, Stefan Becker, Untertitel per "-s" an dvdauthor uebergeben
 *  11.02.2004, Stefan Becker, Auch bei transcode/mplayer 2 Audiotracks deutsch/englisch rippen (0.50)
 *                             Bei vamps ueber dvdunauthor auslesen, Patch fuer dvdauthor
 *  13.02.2004, Stefan Becker, dvdbackup einbinden fuer eigene Rohlinge (0.60)
 *                             Abfrage auf freien Plattenplatz abschaltbar (-free=)
 *                             Audiotracks frei waehlbar (-a=5) inkl. Auflistung
 *  14.02.2004, Stefan Becker, Bei Fehler von "dvdauthor -T" die Authorisierung wiederholen (0.61)
 *                             Teste, ob "VIDEO_TS" da und schalte bei Fehler um auf "video_ts"
 *  15.02.2004, Stefan Becker, Am Ende Dateien nur loeschen wenn Brennen OK (0.62)
 *                             Speed und Key fuer cdrecord-prodvd setzen 
 *                             cdrecord-prodvd on the fly
 *  16.02.2004, Stefan Becker, Optimierung der transcode Methode mit parallelen Pipes (0.70 pre)
 *                             Transcode Parallel fuer CBR-DVDs.
 *                             Parameter "-S 0" bei mplex angehaengt, sonst Abbruch bei 2 GB.
 *  17.02.2004, Stefan Becker, "palette.txt" fuer Untertitel auslesen.
 *                             Auch bei transcode/mplayer die Untertitel auslesen mit spuumux/spumux.
 *  18.02.2004, Stefan Becker, spuunmux ueber dvdunauthor.
 *                             Sprachauswahl "a=5" auf "a=l" fuer Liste umgestellt.
 *                             Option "u=l" zur Auswahl von Untertiteln.
 *                             Warnung, wenn bei mplayer/transcode anderes Format als ac3 ausgewaehlt.
 *                             Mit dvdbackup-Funktionen Groesse der DVD bestimmen.
 *                             DVDs kleiner als 4,7 GB mit dvdbackup sichern (Vorschlag).
 *  19.02.2004, Stefan Becker, bei Transcode frei Audiowahl freischalten. 
 *  19.02.2004, Stefan Becker, Fehler bei mplex bei Transcode mit Auditrackmethode a=l behoben (0.70 pre2)
 *  20.02.2004, Stefan Becker, Fehler bei Audiomethode a=l und unbekannter Sprache behoben (0.70 pre3)
 *  20.02.2004, Stefan Becker, Anzeige Dateigroesse beim ls des Inhalts geaendert (0.70 pre4)
 *  21.02.2004, Stefan Becker, 1:1 Kopiermodus per vamps/dvdbackup
 *  21.02.2004, Stefan Becker, beim 1:1 Modus nachher noch "dvdauthor -T" aufrufen, um die Hauptifo neu 
 *                             zu erzeugen, noetig, damit mkisofs geht. (0.70 pre 5) 
 *  21.02.2004, Stefan Becker, 1:1 Kopiermodus wieder entfernt, geht nicht. Finalversion (0.70)
 *  21.02.2004, Stefan Becker, bei transcode/mplayer Umstellung auf "dvdauthor ... -f 'mplex ... |'" (0.71)
 *  22.02.2004, Stefan Becker, Zuordnung tcmplex an Kommandozeile korrigiert (-mp=tcmplex)
 *                             Neuer Parameter "-cbr=".
 *                             Bei mplayer/transcode Files am Ende nicht loeschen, wenn Fehlschlag dvdauthor.
 *                             Nur bis zum vorletzten Kapitel die Kapitelliste fuellen.
 *                             Wenn dvdunauthor nicht gefunden, nehme tccat bei vamps.
 *  22.02.2004, Stefan Becker, Neuer Parameter "-file=" fuer Ausgabe in Datei statt dvdauthor+Brennen (0.72)
 *  24.02.2004, Stefan Becker, Methode transcode / mplex / dvdauthor per Pipes (0.80 pre 1)
 *                             vamps-Methode entfernt.
 *                             Bei transcode/mplayer Untertitel jetzt mit subtitleripper statt spumux rippen.
 *  25.02.2004, Stefan Becker, Fehler bei Auswahl streamtool als Kommandozeilenparameter behoben (0.80 pre 2)
 *  26.02.2004, Stefan Becker, Programmnamen als Parameter, jeweils mit Pfad moeglich.
 *  28.02.2004, Stefan Becker, Testrippen von vamps auf tccat/tcextract umgestellt.
 *                             Ueberpruefung der eingesetzten Programme.
 *                             Aenderungen aus Patch von apogoda integriert (0.80 pre 3).
 *                             Aenderungen: Handling von Temp-Dateien.
 *                             Untertitel automatisch per Sprache waehlen (-u=de).
 *  29.02.2004, Stefan Becker, mpeg1 Audio Streams mit transcode (0.80 pre 4)
 *  01.03.2004, Stefan Becker, Bugfixes fuer gcc 2.95 (0.80 pre 5)
 *  02.03.2004, Stefan Becker, Noch ein Bugfix fuer gcc 2.95 (0.80)
 *                             Parameter "dvdcompat=" fuer growisofs (0.90 pre 1)
 *  03.03.2004, Stefan Becker, Faktor berechnen mit streamanalyze
 *  04.03.2004, Stefan Becker, Audiomethode 5: lpcm Audiostreams mit transcode kopieren
 *                                             bei mpeg1 Audio 192 KBPS als Bitrate einstellen
 *                                             lpcm und mpeg1 Audiostreams mit Transcode parallel
 *  06.03.2004, Stefan Becker, mpeg1 auf neutral "mpeg"-Audio geaendert (0.90 pre 2)
 *                             Korrektur Auiostream-IDs bei streamanalyze, streamdvd
 *                             Patch von S. Lichtenhagen (Korrektur Meldungen, growisofs Aufruf) (0.90 pre 3)   
 *                             Parameter "-sc=" Palette fuer subtitle2pm
 *                             mpeg- und lpcm Audiostreams auch mit streamdvd (0.90 pre 4)
 *                             Kein Abbruch bei tcmplex bei tc parallel, sondern automatisch korrekte Wahl einstellen.
 *                             Bei streamanalyze Sicherheitsreserve bei mplayer/transcode.
 *                             Fix bei Untertitel (0x%x statt 0x%ld). Ausgabepufferung stdout abgeschaltet.
 *                             Bei dvdbackup Verzeichnis AUDIO_TS manuell anlegen.
 *  16.03.2004, Stefan Becker, Bei Berechnung freier Speicherplatz Ergebnis ausgeben. (0.90)
 *                             1:1 Kopie DVD groesser 4.7 GB per dvdunauthor/vamps
 *  22.03.2004, Stefan Becker, Fehler bei Setzen des DVD-Namen geaendert (0.91)
 *                             dvdbackup mit "-n" aufrufen.
 *  31.03.2004, Stefan Becker, Untertitel wieder mit spuunmux, da inzwischen performant (1.00 pre 1)
 *  02.04.2004, Stefan Becker, Untertitel auch bei transcode parallel
 *  03.04.2004, Stefan Becker, Untertitel bei trans_par optimiert (1.00 pre 2)
 *                             DVD auswerfen nach Rippen
 *  04.04.2004, Stefan Becker, DVD RW formatieren vor dem Brennen (1.00 pre 3)
 *  07.04.2004, Stefan Becker, Bei dvdcopy mit vamps und Faktor kleiner 1 vamps weglassen (1.00 pre 4)
 *                             2. Untertitelspur bei Transcode seriell, mplayer, streamanalyze, 
 *                             streamdvd
 *                             und bei transcode parallel (1.00)
 *  15.04.2004, Stefan Becker, bei allen transcode Methoden mplayer fuer dts-Audio (1.01)
 *  16.04.2004, Stefan Becker, mplayer fuer alle Audiocodecs freischalten (bisher nur ac3)
 *  27.04.2004, Stefan Becker, Hilfe formatiert (1.02)
 *                             Berechnung Groesse: Wenn kein Titleset, nicht berechnen (sonst Absturz)  
 *
 */

#define VERSION "1.02"


#include <dvdread/dvd_reader.h>
#include <dvdread/ifo_read.h>
#include <dvdread/ifo_print.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


// Typen zur Info der Struktur, aus dvdbackup
typedef struct {
  int		size_ifo;
  int		size_menu;
  int		size_bup;
  int		number_of_vob_files;
  int		size_vob[10];
} title_set_t;

typedef struct {
  int		number_of_title_sets;
  title_set_t  *title_set;
} title_set_info_t;


typedef struct {
  int		title;
  int		title_set;
  int		vts_title;
  int		chapters;
  int		aspect_ratio;
  int		angles;
  int		audio_tracks;
  int		audio_channels;
  int		sub_pictures;
} titles_t;

typedef struct {
  int		main_title_set;
  int		number_of_titles;
  titles_t	*titles;
} titles_info_t;


/*
   Simple helper macros for generating Perl structures
*/
static int _lvl = 0;
static int _lvl_type[256];
#define INDENT  { int i; for(i=0; i<_lvl; i++) printf("  "); }
#define DEF(name, x...) {               \
 INDENT;                                \
 printf("%s => ", name);                \
 printf(x); printf(",\n");              \
}
#define HASH(name) {                                            \
 INDENT;                                                        \
 (name ?							\
   printf((_lvl ? "%s => {\n" : "our %%%s = (\n"), name) :	\
   printf("{\n"));						\
 _lvl++; _lvl_type[_lvl] = 0;                                   \
}
#define ARRAY(name) {					\
 INDENT;						\
 printf(_lvl ? "%s => [\n" : "our @%s = (\n", name);	\
 _lvl_type[_lvl] = 1;	_lvl++;				\
}
#define RETURN  { _lvl--; INDENT;					\
 opt_p ? printf("%s\n", 						\
    _lvl ?   (_lvl_type[_lvl] ? "]," : "},")	:	");") : _lvl++;		\
}
#define START {		\
  HASH("lsdvd");	\
}
#define STOP {		\
  while(_lvl) RETURN;	\
}

static struct { char code[3];	char name[20];}
language[] = {
	{ "  ", "Not Specified" }, { "aa", "Afar" },	{ "ab", "Abkhazian" }, { "af", "Afrikaans" },	{ "am", "Amharic" },
	{ "ar", "Arabic" }, { "as", "Assamese" },	{ "ay", "Aymara" }, { "az", "Azerbaijani" }, { "ba", "Bashkir" },
	{ "be", "Byelorussian" }, { "bg", "Bulgarian" }, { "bh", "Bihari" }, { "bi", "Bislama" }, { "bn", "Bengali; Bangla" },
	{ "bo", "Tibetan" }, { "br", "Breton" }, { "ca", "Catalan" }, { "co", "Corsican" }, { "cs", "Czech" },
	{ "cy", "Welsh" }, { "da", "Dansk" }, { "de", "Deutsch" }, { "dz", "Bhutani" }, { "el", "Greek" }, { "en", "English" },
	{ "eo", "Esperanto" }, { "es", "Espanol" }, { "et", "Estonian" }, { "eu", "Basque" }, { "fa", "Persian" },
	{ "fi", "Suomi" }, { "fj", "Fiji" }, { "fo", "Faroese" }, { "fr", "Francais" }, { "fy", "Frisian" }, { "ga", "Gaelic" },
	{ "gd", "Scots Gaelic" }, { "gl", "Galician" }, { "gn", "Guarani" }, { "gu", "Gujarati" }, { "ha", "Hausa" },
	{ "he", "Hebrew" }, { "hi", "Hindi" }, { "hr", "Hrvatski" }, { "hu", "Magyar" }, { "hy", "Armenian" },
	{ "ia", "Interlingua" }, { "id", "Indonesian" }, { "ie", "Interlingue" }, { "ik", "Inupiak" }, { "in", "Indonesian" },
	{ "is", "Islenska" }, { "it", "Italiano" }, { "iu", "Inuktitut" }, { "iw", "Hebrew" }, { "ja", "Japanese" },
	{ "ji", "Yiddish" }, { "jw", "Javanese" }, { "ka", "Georgian" }, { "kk", "Kazakh" }, { "kl", "Greenlandic" },
	{ "km", "Cambodian" }, { "kn", "Kannada" }, { "ko", "Korean" }, { "ks", "Kashmiri" }, { "ku", "Kurdish" },
	{ "ky", "Kirghiz" }, { "la", "Latin" }, { "ln", "Lingala" }, { "lo", "Laothian" }, { "lt", "Lithuanian" },
	{ "lv", "Latvian, Lettish" }, { "mg", "Malagasy" }, { "mi", "Maori" }, { "mk", "Macedonian" }, { "ml", "Malayalam" },
	{ "mn", "Mongolian" }, { "mo", "Moldavian" }, { "mr", "Marathi" }, { "ms", "Malay" }, { "mt", "Maltese" },
	{ "my", "Burmese" }, { "na", "Nauru" }, { "ne", "Nepali" }, { "nl", "Nederlands" }, { "no", "Norsk" }, { "oc", "Occitan" },
	{ "om", "Oromo" }, { "or", "Oriya" }, { "pa", "Punjabi" }, { "pl", "Polish" }, { "ps", "Pashto, Pushto" },
	{ "pt", "Portugues" }, { "qu", "Quechua" }, { "rm", "Rhaeto-Romance" }, { "rn", "Kirundi" }, { "ro", "Romanian"  },
	{ "ru", "Russian" }, { "rw", "Kinyarwanda" }, { "sa", "Sanskrit" }, { "sd", "Sindhi" }, { "sg", "Sangho" },
	{ "sh", "Serbo-Croatian" }, { "si", "Sinhalese" }, { "sk", "Slovak" }, { "sl", "Slovenian" }, { "sm", "Samoan" },
 	{ "sn", "Shona"  }, { "so", "Somali" }, { "sq", "Albanian" }, { "sr", "Serbian" }, { "ss", "Siswati" },
	{ "st", "Sesotho" }, { "su", "Sundanese" }, { "sv", "Svenska" }, { "sw", "Swahili" }, { "ta", "Tamil" },
	{ "te", "Telugu" }, { "tg", "Tajik" }, { "th", "Thai" }, { "ti", "Tigrinya" }, { "tk", "Turkmen" }, { "tl", "Tagalog" },
	{ "tn", "Setswana" }, { "to", "Tonga" }, { "tr", "Turkish" }, { "ts", "Tsonga" }, { "tt", "Tatar" }, { "tw", "Twi" },
	{ "ug", "Uighur" }, { "uk", "Ukrainian" }, { "ur", "Urdu" }, { "uz", "Uzbek" }, { "vi", "Vietnamese" },
	{ "vo", "Volapuk" }, { "wo", "Wolof" }, { "xh", "Xhosa" }, { "yi", "Yiddish" }, { "yo", "Yoruba" }, { "za", "Zhuang" },
	{ "zh", "Chinese" }, { "zu", "Zulu" }, { "xx", "Unknown" }, { "\0", "Unknown" } };
char *video_format[2] = {"NTSC", "PAL"};
/* 28.9.2003: Chicken run's aspect ratio is 16:9 or 1.85:1, at index
   1.  Addionaly using ' in the quoting makes the perl output not
   parse so changed to " */
char *aspect_ratio[4] = {"4/3", "16/9", "\"?:?\"", "16/9"};
char *quantization[4] = {"16bit", "20bit", "24bit", "drc"};
char *mpeg_version[2] = {"mpeg1", "mpeg2"};
/* 28.9.2003: The European chicken run title has height index 3, and
   576 lines seems right, mplayer -vop cropdetect shows from 552 to
   576 lines.  What the correct value is for index 2 is harder to say */
char *video_height[4] = {"480", "576", "???", "576"};
char *video_width[4]  = {"720", "704", "352", "352"};
char *permitted_df[4] = {"P&S + Letter", "Pan&Scan", "Letterbox", "?"};
char *audio_format[7] = {"ac3", "?", "mpeg1", "mpeg2", "lpcm ", "sdds ", "dts"};
/* 28.9.2003: Chicken run again, it has frequency index of 1.
   According to dvd::rip the frequency is 48000 */
char *sample_freq[2]  = {"48000", "48000"};
char *audio_type[5]   = {"Undefined", "Normal", "Impaired", "Comments1", "Comments2"};
char *subp_type[16]   = {"Undefined", "Normal", "Large", "Children", "reserved", "Normal_CC", "Large_CC", "Children_CC",
	"reserved", "Forced", "reserved", "reserved", "reserved", "Director", "Large_Director", "Children_Director"};
double frames_per_s[4] = {-1.0, 25.00, -1.0, 29.97};

char* program_name;

// Input Buffer leeren
void eatToNL(FILE * inputStream)
{
    int c;
    /* Eat till (& including) the next newline */
    while ((c = getc(inputStream)) != EOF)
       if (c == '\n')
           break;
}


// Test, ob das gewuenschte Programm vorhanden ist.
void check_program (char * szProgram, long lSprache)
{
  struct stat tmpStat;
  char filename[255];
  long bGefunden = 0;
  printf ("Test %s", szProgram);
  // Wenn kein Pfad gesetzt, dann im gesamten Pfad suchen
  if (!strstr (szProgram, "/"))
  {
    char szPfad[4096];
    int i;
    char szVerzeichnis[1024];
    strcpy (szPfad, getenv ("PATH"));
    strcpy (szVerzeichnis, "");
    for (i=0; i<strlen(szPfad); i++)
    {
      if (szPfad[i] == ':')
      {
        strcat (szVerzeichnis, "/");
        strcat (szVerzeichnis, szProgram);
        if (stat (szVerzeichnis, &tmpStat) == 0) 
        {
          bGefunden = 1;
          break;
        }
        strcpy (szVerzeichnis, "");
      } else
      {
        sprintf (szVerzeichnis, "%s%c", szVerzeichnis, szPfad[i]);
      }
    }   
    if (bGefunden == 0)
    {
      strcat (szVerzeichnis, "/");
      strcat (szVerzeichnis, szProgram);
      if (stat (szVerzeichnis, &tmpStat) == 0) 
      {
        bGefunden = 1;
      }
    }
  } else
  {   
    if (stat (szProgram, &tmpStat) == 0) 
    {
      bGefunden = 1;
    }
  }
  // Wenn nicht gefunden, Abbruch
  if (bGefunden==0)
  {
    char szWeiter;
    if (lSprache==0)
    {
      printf (": nicht gefunden!\n");
      printf ("i=ignorieren, sonst Abbruch:");
    } else
    {
      printf (": Program not found\n");
      printf ("i=ignore, else cancel:");
    }
    scanf ("%c", &szWeiter);
    if (szWeiter != 'i')
    {
      if (lSprache==0)
        printf ("\nlxdvdrip wird beendet!\n");
      else
        printf ("\nlxdvdrip is canceled!\n");
      exit(0);
    }
    eatToNL(stdin);
  } else
  {
    printf (": OK\n");
  }
}


// Berechnet Groessen der VOB-Dateien
long long calculate_filesize (char * szVerzeichnis, char * szVideoTS, char *szVobTS, char * szVtsTS)
{
  long long FileSize=0;
  int i;
  for (i=1; i<1000; i++)
  {
    struct stat tmpStat;
    char filename[255];
    sprintf (filename, "%s/%s/%s_01_%d.%s", szVerzeichnis, szVideoTS, szVtsTS, i, szVobTS);
    if (stat (filename, &tmpStat) != 0) // keine weitere Datei vorhanden
    {
      break;
    }
    FileSize += tmpStat.st_size;
  }
  return FileSize;
}


// Gibt die Groesse einer Datei zurueck, ohne die stat Beschraenkung auf < 2 GB
long long filesize64 (char * szFileName)
{
  FILE * fp;
  long long lSize;
  char szBuffer[128];
  char szTempl[32] = "/tmp/groesse.XXXXXX";
  fp = (FILE*)fopen64 (szFileName, "rb");
  if (!fp)
  {
    return (long long)0;
  }
  fclose (fp);
  mkstemp(szTempl);
  sprintf (szBuffer, "du -b %s > %s", szFileName, szTempl);
  system (szBuffer);
  fp = fopen (szTempl, "rb");
  fscanf (fp, "%s", szBuffer);
  fclose (fp);
  unlink(szTempl);
  lSize = atoll (szBuffer);
  return lSize;
}

// Berechnet freien Festplattenplatz
long long calculate_discfree (char * szPfad, long lSprache)
{
  char szTempl[32] = "/tmp/lxdf.XXXXXX";
  char szBefehl[1024];
  long long lGroesse=0;
  sprintf (szBefehl, "stat -f %s -c ", szPfad);
  mkstemp(szTempl);
  strcat (szBefehl, "'%a %s' > ");
  strcat (szBefehl, szTempl);
  if (system (szBefehl) == 0)
  {
    FILE * fTmp;
    long long lFrei;
    long long lBlockGroesse;
    fTmp = fopen(szTempl,"r");
    if (fTmp)
    {
      fscanf (fTmp, "%lld %lld", &lFrei, &lBlockGroesse);
      fclose (fTmp);
      lGroesse = lFrei * lBlockGroesse;
    }
    unlink(szTempl);
    if (lSprache==0)
      printf ("Frei in %s: %lld Bytes\n", szPfad, lGroesse);
    else
      printf ("Free in %s: %lld Bytes\n", szPfad, lGroesse);
  }
  return lGroesse;
}


// Findet Device-ID eines Verzeichnisses
long device_number (char * szPfad)
{
  char szTempl[32] = "/tmp/lxdf.XXXXXX";
  char szBefehl[1024];
  long lDevice=0;
  sprintf (szBefehl, "stat %s -c ", szPfad);
  mkstemp(szTempl);
  strcat (szBefehl, "'%d' > ");
  strcat (szBefehl, szTempl);
  if (system (szBefehl) == 0)
  {
    FILE * fTmp;
    fTmp = fopen (szTempl, "r");
    if (fTmp)
    {
      fscanf (fTmp, "%ld", &lDevice);
      fclose (fTmp);
    }
    unlink(szTempl);
  }
  return lDevice;
}


int dvdtime2msec(dvd_time_t *dt)
{
  double fps = frames_per_s[(dt->frame_u & 0xc0) >> 6];
  long   ms;
  ms  = (((dt->hour &   0xf0) >> 3) * 5 + (dt->hour   & 0x0f)) * 3600000;
  ms += (((dt->minute & 0xf0) >> 3) * 5 + (dt->minute & 0x0f)) * 60000;
  ms += (((dt->second & 0xf0) >> 3) * 5 + (dt->second & 0x0f)) * 1000;

  if(fps > 0)
  ms += ((dt->frame_u & 0x30) >> 3) * 5 + (dt->frame_u & 0x0f) * 1000.0 / fps;

  return ms;
}


// Funktion aus lsdvd uebernommen
// berechnet Zeit fuer Chapterunterteilung
int millisekunden(dvd_time_t *dt)
{
  double fps = frames_per_s[(dt->frame_u & 0xc0) >> 6];
  long   ms;
  ms  = (((dt->hour &   0xf0) >> 3) * 5 + (dt->hour   & 0x0f)) * 3600000;
  ms += (((dt->minute & 0xf0) >> 3) * 5 + (dt->minute & 0x0f)) * 60000;
  ms += (((dt->second & 0xf0) >> 3) * 5 + (dt->second & 0x0f)) * 1000;

  if(fps > 0)
  ms += (((dt->frame_u & 0x30) >> 3) * 5 + (dt->frame_u & 0x0f)) * 1000.0 / fps;

  return ms;
}

/*
 *  The following method is based on code from vobcopy, by Robos, with thanks.
 */

int get_title_name(const char* dvd_device, char* title, long lSprache)
{
  FILE *filehandle = 0;
  int  i;

  if (! (filehandle = fopen(dvd_device, "r"))) {
    if (lSprache == 0)
      fprintf(stderr, "Kann von DVD-Device %s nicht lesen!\n", dvd_device);
    else
      fprintf(stderr, "Couldn't open %s for title!\n", dvd_device);
    strcpy(title, "unknown");
    return -1;
  }

  if ( fseek(filehandle, 32808, SEEK_SET )) {
    fclose(filehandle);
    if (lSprache == 0)
      fprintf(stderr, "Konnte nicht auf DVD-Device %s suchen!\n", dvd_device);
    else
      fprintf(stderr, "Couldn't seek in %s for title!\n", dvd_device);
    strcpy(title, "unknown");
    return -1;
  }

  if ( 32 != (i = fread(title, 1, 32, filehandle)) ) {
    fclose(filehandle);
    if (lSprache == 0)
      fprintf(stderr, "Konnte nicht genuegend Bytes lesen!\n");
    else
      fprintf(stderr, "Couldn't read enough bytes for title!\n");
    strcpy(title, "unknown");
    return -1;
  }

  fclose (filehandle);

  title[32] = '\0';
  while(i-- > 2)
     if(title[i] == ' ') title[i] = '\0';
  return 0;
}

char* lang_name(char* code)
{
	int k=0;
	while (memcmp(language[k].code, code, 2) && language[k].name[0] ) { k++; }
	return language[k].name;
}


// Funktionen aus dvdbackup zur Bestimmung der Groesse der DVD
void DVDFreeTitleSetInfo(title_set_info_t * title_set_info) {
	free(title_set_info->title_set);
	free(title_set_info);
}

void DVDFreeTitlesInfo(titles_info_t * titles_info) {
	free(titles_info->titles);
	free(titles_info);
}

title_set_info_t *DVDGetFileSet(dvd_reader_t * _dvd) {

#define MAXNAME 256
int verbose=0;

	/* title interation */
	int title_sets, counter, i;


	/* DVD Video files */
	char	filename[MAXNAME];
	int	size;

	/*DVD ifo handler*/
	ifo_handle_t * 	vmg_ifo=NULL;

	/* The Title Set Info struct*/
	title_set_info_t * title_set_info;

	/*  Open main info file */
	vmg_ifo = ifoOpen( _dvd, 0 );
	if( !vmg_ifo ) {
        	fprintf( stderr, "Can't open VMG info.\n" );
        	return (0);
    	}


	title_sets = vmg_ifo->vmgi_mat->vmg_nr_of_title_sets;

	/* Close the VMG ifo file we got all the info we need */
        ifoClose(vmg_ifo);

	/* Todo fix malloc check */
	title_set_info = (title_set_info_t *)malloc(sizeof(title_set_info_t));
	title_set_info->title_set = (title_set_t *)malloc((title_sets + 1)* sizeof(title_set_t));

	title_set_info->number_of_title_sets = title_sets;


	/* Find VIDEO_TS.IFO is present - must be present since we did a ifo open 0*/

	sprintf(filename,"/VIDEO_TS/VIDEO_TS.IFO");

	if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
		title_set_info->title_set[0].size_ifo = size;
	} else {
		DVDFreeTitleSetInfo(title_set_info);
		return(0);
	}



	/* Find VIDEO_TS.VOB if present*/

	sprintf(filename,"/VIDEO_TS/VIDEO_TS.VOB");

	if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
		title_set_info->title_set[0].size_menu = size;
	} else {
		title_set_info->title_set[0].size_menu = 0 ;
	}

	/* Find VIDEO_TS.BUP if present */

	sprintf(filename,"/VIDEO_TS/VIDEO_TS.BUP");

	if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
		title_set_info->title_set[0].size_bup = size;
	} else {
		DVDFreeTitleSetInfo(title_set_info);
		return(0);
	}

	if (title_set_info->title_set[0].size_ifo != title_set_info->title_set[0].size_bup) {
		fprintf(stderr,"BUP and IFO size not the same be warned!\n");
	}


	/* Take care of the titles which we don't have in VMG */

	title_set_info->title_set[0].number_of_vob_files = 0;
	title_set_info->title_set[0].size_vob[0] = 0;


	if ( verbose > 0 ){
		fprintf(stderr,"\n\n\nFile sizes for Title set 0 VIDEO_TS.XXX\n");
		fprintf(stderr,"IFO = %d, MENU_VOB = %d, BUP = %d\n",title_set_info->title_set[0].size_ifo, title_set_info->title_set[0].size_menu, title_set_info->title_set[0].size_bup );

	}


	if ( title_sets >= 1 ) {
 		for (counter=0; counter < title_sets; counter++ ){

			if ( verbose > 1 ){
				fprintf(stderr,"At top of loop\n");
			}


			sprintf(filename,"/VIDEO_TS/VTS_%02i_0.IFO",counter + 1);

			if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
				title_set_info->title_set[counter + 1].size_ifo = size;
			} else {
				DVDFreeTitleSetInfo(title_set_info);
				return(0);
			}

			if ( verbose > 1 ){
				fprintf(stderr,"After opening files\n");
			}


			/* Find VTS_XX_0.VOB if present*/

			sprintf(filename,"/VIDEO_TS/VTS_%02i_0.VOB", counter + 1);

			if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
				title_set_info->title_set[counter + 1].size_menu = size;
			} else {
				title_set_info->title_set[counter + 1].size_menu = 0 ;
			}


			if ( verbose > 1 ){
				fprintf(stderr,"After Menu VOB check\n");
			}


			/* Find all VTS_XX_[1 to 9].VOB files if they are present*/

			for( i = 0; i < 9; ++i ) {
				sprintf(filename,"/VIDEO_TS/VTS_%02i_%i.VOB", counter + 1, i + 1 );
				if(UDFFindFile(_dvd, filename, &size) == 0 ) {
					break;
				}
				title_set_info->title_set[counter + 1].size_vob[i] = size;
			}
			title_set_info->title_set[counter + 1].number_of_vob_files = i;

			if ( verbose > 1 ){
				fprintf(stderr,"After Menu Title VOB check\n");
			}


			sprintf(filename,"/VIDEO_TS/VTS_%02i_0.BUP", counter + 1);

			if ( UDFFindFile(_dvd, filename, &size) != 0 ) {
				title_set_info->title_set[counter +1].size_bup = size;
			} else {
				DVDFreeTitleSetInfo(title_set_info);
				return(0);
			}

			if (title_set_info->title_set[counter +1].size_ifo != title_set_info->title_set[counter + 1].size_bup) {
				fprintf(stderr,"BUP and IFO size for fileset %d is not the same be warned!\n", counter + 1);
			}



			if ( verbose > 1 ){
				fprintf(stderr,"After Menu Title BUP check\n");
			}


			if ( verbose > 0 ) {
				fprintf(stderr,"\n\n\nFile sizes for Title set %d i.e.VTS_%02d_X.XXX\n", counter + 1, counter + 1);
				fprintf(stderr,"IFO: %d, MENU: %d\n", title_set_info->title_set[counter +1].size_ifo, title_set_info->title_set[counter +1].size_menu);
				for (i = 0; i < title_set_info->title_set[counter + 1].number_of_vob_files ; i++) {
					fprintf(stderr, "VOB %d is %d\n", i + 1, title_set_info->title_set[counter + 1].size_vob[i]);
				}
				fprintf(stderr,"BUP: %d\n",title_set_info->title_set[counter +1].size_bup);
			}

			if ( verbose > 1 ){
				fprintf(stderr,"Bottom of loop \n");
			}
		}

        }

	/* Return the info */
	return(title_set_info);


}


int main(int argc, char *argv[])
{
        char title[33];
	dvd_reader_t *dvd;
	ifo_handle_t *ifo_zero, **ifo;
	pgcit_t *vts_pgcit;
	vtsi_mat_t *vtsi_mat;
	vmgi_mat_t *vmgi_mat;
	audio_attr_t *audio_attr;
	video_attr_t *video_attr;
	subp_attr_t *subp_attr;
	pgc_t *pgc;
	int i, j, titles, cell, vts_ttn, title_set_nr;
 	char lang_code[2];
	char dvd_device[128];
	int has_title = 0, ret = 0;
        int max_length = 0, max_track = 0;
	struct stat dvd_stat;
	int opt_a=0, opt_c=0, opt_n=0, opt_p=0, opt_q=0, opt_s=0, opt_t=0, opt_v=0, opt_d=0;
        long lAnzahlSekunden=0;
        long lAnzahlSektoren=0;
        long lAnzahlKapitel=0;

        long lAudioTrackInput1=0; // freie Eingabe der Audiotracks
        long lAudioTrackInput2=0;
        char szSpracheInput1[128];
        char szSpracheInput2[128];
        char szFormatInput1[128];
        char szFormatInput2[128];
        long long lLaengeInput1;
        long long lLaengeInput2;

        long lAnzahlAudioStreams=0;
        long lAudioTrackDeutsch=0;
        long long lPlatzAudio=0;
        long long lPlatzVideo=0;
        long long lPlatzAudioDeutsch=0;
        long long lPlatzAudioEnglisch=0;
        char szAudioFormatDeutsch[128];
        long lAnzahlChannelDeutsch=0;
        long lAudioTrackEnglisch=0;
        char szAudioFormatEnglisch[128];
        long lAnzahlChannelEnglisch=0;
        long lAnzahlAudioTracks;
        char szAudioFormatAllgemein[128];
        char szZusatzSprache[10];
        char szZusatzAudioFormat[128];
        long lZusatzAudioTrack=0;
        long long lZusatzPlatzAudio=0;
        long lZusatzAnzahlChannel;
        long lSprachAuswahl=0;
        double dFaktor;
        char szFilmVerzeichnis[128];
        char szAltesFilmVerzeichnis[128];
        char szRipTracks[128];
        char szBefehl[4096];
        char szBefehl2[4096];
        char szDVDBrenner[512];
        char szVOBPlayer[255];
        long lBrennProgramm=0; // Kein Brennen
        long lWaitBurn=1;      // Sicherheitsabfrage fuers Warten auf Rohling
        long lPackMethode;
        long lSprache=0; // deutsch
        long lShowHelp=0; // keine Hilfe anzeigen
        long lAudioDefault; 
        long lLoeschen;
        char szTmpDir[255];
        long lMultiplexer;
        long long lGroesseDVDBytes;
        long long lGroesseDVDBytesMaximal;
        long lDebugLevel=0;  // moeglichst wenige Meldungen
        char szConfigVersion[128];
        char szChapterString[2048];
        char szDVDName[128];
        char szDVDNameOverwrite[128];
        long lMitKapiteln;

        char szUntertitelOptionen[128];
        char szPaletteFile[] = "/tmp/paletteXXXXXX";
        long lPaletteVorhanden=0;
        char szPaletteOptions[128];
        long lUntertitel=0;
        long lUntertitel2=0;
        char szUntertitelSprache[128];

        long lTestFree;
        long lDVDSpeed;
        char szCDRSecurity[1024];  
        long lRWFormat;

        // Auflistung der verwendeten Programme
        char dvdauthor_name[128];
        char streamdvd_name[128];
        char streamanalyze_name[128];
        char buffer_name[128];
        char tccat_name[128];
        char tcextract_name[128];
        char tcrequant_name[128];
        char mplayer_name[128];
        char mplex_name[128];
        char tcmplex_name[128];
        char spumux_name[128];
        char spuunmux_name[128];
        char dvdbackup_name[128];
        char dvdunauthor_name[128];
        char vamps_name[128];
        char tcprobe_name[128];
        char mkisofs_name[128];
        char cdrecord_prodvd_name[128];
        char growisofs_name[128];
        char eject_name[128];
        char dvdformat_name[128];

        long lEject;

        char szOutputFile[256]; // Ausgabe in Datei statt Brennen

        long lTestKapitel = 0; // Testkapitel rippen
        long lSektorenTestkapitel=0;

        FILE * fConf;
        char szVideoTS[128];
        char szAudioTS[128];
        char szVobTS[128];
        char szVtsTS[128];
        long long lGroesseDVDGesamt=0;
	title_set_info_t * title_set_info=NULL;
	titles_info_t * titles_info=NULL;
        long lGebrannt=0;
        long dvdcompat=0;

	program_name = argv[0];

        // Verwendete Programme setzen, werden mit Daten aus Konfig ueberschrieben
        strcpy (dvdauthor_name, "dvdauthor");  
        strcpy (streamdvd_name,"streamdvd");
        strcpy (streamanalyze_name,"streamanalyze");
        strcpy (buffer_name,"buffer");
        strcpy (tccat_name,"tccat");
        strcpy (tcextract_name,"tcextract");
        strcpy (tcrequant_name,"tcrequant");
        strcpy (mplayer_name,"mplayer");
        strcpy (mplex_name,"mplex");
        strcpy (tcmplex_name,"tcmplex");
        strcpy (spumux_name,"spumux");
        strcpy (spuunmux_name,"spuunmux");
        strcpy (dvdbackup_name,"dvdbackup");
        strcpy (dvdunauthor_name,"dvdunauthor");
        strcpy (vamps_name,"vamps");
        strcpy (tcprobe_name,"tcprobe");
        strcpy (mkisofs_name,"mkisofs");
        strcpy (cdrecord_prodvd_name,"cdrecord-prodvd");
        strcpy (growisofs_name,"growisofs");
        strcpy (eject_name, "eject");
        strcpy (dvdformat_name, "dvd+rw-format");

        // Gesucht werden Infos zu Audio, Kapiteln und Untertiteln
        opt_a = 1;                // Audio
        opt_c = 1;                // Chapters
        opt_s = 1;                // Zum Auslesen der Untertiteloptionen

        // Programmparameter voreinstellen
        strcpy (dvd_device, "/dev/dvd");             // Default-Device Leser
        opt_t = 0;                                   // laengsten Track selbst bestimmen
        strcpy (szDVDBrenner, "/dev/scd0");          // Device fuer DVD-Brenner
        lSprachAuswahl=1;                            // Standard=deutsch
        strcpy (szFilmVerzeichnis, "/tmp/film-dvd"); // Ablage der gerippten Daten
        lUntertitel = 0;                             // Standard ohne Untertitel
        strcpy (szVOBPlayer, "mplayer");             // keine VOB-Vorschau
        lBrennProgramm=1;                            // Brennen per growisofs
        dFaktor = 0;                                 // selbst ausrechnen
        lPackMethode = 1;                            // streamdvd als Default
        lAudioDefault = 0;                           // immer den ersten passenden Track waehlen
        strcpy (szTmpDir, "/tmp");                   // Verzeichnis fuer Dateiablage bei mplayer-Rip
        lLoeschen=1;                                 // am Ende alle VOBS loeschen
        lMultiplexer=1;                              // tcmplex als Default
        strcpy (szZusatzSprache, "");                // per Default keine andere Sprache als deutsch und englisch)
        strcpy (szConfigVersion, "");
        strcpy (szChapterString, "");                // Chapter Unterteilung bestimmen
        strcpy (szDVDName, "");                      // DVD-Name, wird spaeter bestimmt
        strcpy (szDVDNameOverwrite, "");             // Falls dieser Name ueberschrieben werden soll
        lMitKapiteln = 1;                            // Inkl. Kapitelunterteilung vom Original
        strcpy (szUntertitelOptionen, "");           // ohne Untertitel-Optionen
        strcpy (szUntertitelSprache, "");            // ohne festgelegte Untertitel per Sprache
        lTestFree = 1;                               // Testen auf freien Plattenplatz
        lDVDSpeed=0;                                 // Speed fuers Brennen
        strcpy (szCDRSecurity, "");                  // Schluessel fuers Brennen
        strcpy (szOutputFile, "");                   // Als Standard keine Ausgabe in Datei
        lEject = 0;                                  // DVD nach Rippen nicht auswerfen
        lRWFormat = 0;                               // RWs nicht formatieren vor dem Brennen

        // Folgende Definitionen, um Compiler Warnings zu fixen (zu gross fuer long)
        lGroesseDVDBytes        = (long long)460000000 * 10;
        lGroesseDVDBytesMaximal = (long long)470000000 * 10;

        // Pufferung stdout ausschalten, besser wegen Umlenkung Ausgabe in eine Logdatei.
        setvbuf( stdout, (char *)NULL, _IONBF, 0 );

        // Auslesen der Parameter aus einer Datei
        fConf=fopen("/etc/lxdvdrip.conf", "r");
        if (!fConf)
        {
          printf ("Keine Datei /etc/lxdvdrip.conf vorhanden, verwende Standardeinstellungen!\n\n");
        } else
        {
          char szParameter[1024];
          char szDummy[255];
          while (fscanf(fConf, "%s\n",szParameter) != EOF)
          {
            // Kommentarzeilen ueberlesen
            if (szParameter[0] == '#')
            {
              char c;
              do
              {
                c = fgetc (fConf);
                if (c==10 || c==13) // Zeilenende => Abbruch
                  break;
              } while (1==1);
              continue;
            }
            if (strncmp (szParameter, "version=", 8) == 0)
            {
              strcpy (szConfigVersion, &szParameter[8]);
              continue;
            }
            if (strncmp (szParameter, "titel=", 6) == 0)
            {
              strcpy (szDummy, &szParameter[6]);
              opt_t=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "audio=", 6) == 0)
            {
              strncpy (szDummy, &szParameter[6], 1);
              szDummy[1] = 0;
              if (strcmp (szDummy, "l") == 0) strcpy (szDummy, "5"); // Auswahl per Liste
              lSprachAuswahl=atol(szDummy);
              if (lSprachAuswahl == 4)
              {
                strcpy (szZusatzSprache, &szParameter[8]);
              }
              continue;
            }
            if (strncmp (szParameter, "untertitel=", 11) == 0)
            {
              strcpy (szDummy, &szParameter[11]);
              if ( (strlen (szDummy) == 2) &&
                   (szDummy[0] < '0' || szDummy[0] > '9')
                 )
              {
                strcpy (szUntertitelSprache, szDummy);
                lUntertitel = -2;
              } else
              {
                if (szDummy[0] == 'l')
                  lUntertitel = -1;  // Auwahl per Liste
                else
                  lUntertitel=atol(szDummy);
              }
              continue;
            }
            if (strncmp (szParameter, "faktor=", 7) == 0)
            {
              strcpy (szDummy, &szParameter[7]);
              dFaktor=atof(szDummy);
              continue;
            }
            if (strncmp (szParameter, "dvdleser=", 9) == 0)
            {
              strcpy (dvd_device, &szParameter[9]);
              continue;
            }
            if (strncmp (szParameter, "dvdbrenner=", 11) == 0)
            {
              strcpy (szDVDBrenner, &szParameter[11]);
              continue;
            }
            if (strncmp (szParameter, "filmverzeichnis=", 16) == 0)
            {
              strcpy (szFilmVerzeichnis, &szParameter[16]);
              continue;
            }
            if (strncmp (szParameter, "brennprogramm=", 14) == 0)
            {
              strcpy (szDummy, &szParameter[14]);
              lBrennProgramm=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "chapter=", 8) == 0)
            {
              strcpy (szDummy, &szParameter[8]);
              lMitKapiteln=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "vobplayer=", 10) == 0)
            {
              strcpy (szVOBPlayer, &szParameter[10]);
              continue;
            }
            if (strncmp (szParameter, "language=", 9) == 0)
            {
              if (strcmp (&szParameter[9], "en") == 0) lSprache = 1;
              continue;
            }
            if (strncmp (szParameter, "streamtool=", 11) == 0)
            {
              if (strcmp (&szParameter[11], "streamdvd") == 0) lPackMethode = 1;
              if (strcmp (&szParameter[11], "trans_par") == 0) lPackMethode = 2;
              if (strcmp (&szParameter[11], "mplayer") == 0) lPackMethode = 3;
              if (strcmp (&szParameter[11], "transcode") == 0) lPackMethode = 4;
              if (strcmp (&szParameter[11], "copy") == 0) lPackMethode = 5;
              continue;
            }
            if (strncmp (szParameter, "audio-default=", 14) == 0)
            {
              strcpy (szDummy, &szParameter[14]);
              lAudioDefault=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "free=", 5) == 0)
            {
              strcpy (szDummy, &szParameter[5]);
              lTestFree=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "wait-burn=", 10) == 0)
            {
              strcpy (szDummy, &szParameter[10]);
              lWaitBurn=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "tmp=", 4) == 0)
            {
              strcpy (szTmpDir, &szParameter[4]);
              continue;
            }
            if (strncmp (szParameter, "delete=", 7) == 0)
            {
              strcpy (szDummy, &szParameter[7]);
              lLoeschen=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "mplex=", 6) == 0)
            {
              if (strcmp (&szParameter[6], "tcmplex") == 0) lMultiplexer = 1;
              if (strcmp (&szParameter[6], "mplex") == 0) lMultiplexer = 2;
              continue;
            }
            if (strncmp (szParameter, "speed=", 6) == 0)
            {
              if (strlen (szParameter) > 6) 
              {
                strcpy (szDummy, &szParameter[6]);
                lDVDSpeed=atol(szDummy);
              }
              continue;
            }
            if (strncmp (szParameter, "dvdcompat=", 10) == 0)
            {
              if (strlen (szParameter) > 10) 
              {
                strcpy (szDummy, &szParameter[10]);
                dvdcompat=atol(szDummy);
              }
              continue;
            }
            if (strncmp (szParameter, "burnkey=", 8) == 0)
            {
              if (strlen (szParameter) > 8) 
              {
                strcpy (szCDRSecurity, &szParameter[8]);
              }
              continue;
            }
            if (strstr (szParameter, "dvdauthor_name="))
            {
              strcpy (dvdauthor_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "streamdvd_name="))
            {
              strcpy (streamdvd_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "streamanalyze_name="))
            {
              strcpy (streamanalyze_name, &szParameter[19]);
              continue;
            }
            if (strstr (szParameter, "buffer_name="))
            {
              strcpy (buffer_name, &szParameter[12]);
              continue;
            }
            if (strstr (szParameter, "tccat_name="))
            {
              strcpy (tccat_name, &szParameter[11]);
              continue;
            }
            if (strstr (szParameter, "tcextract_name="))
            {
              strcpy (tcextract_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "tcrequant_name="))
            {
              strcpy (tcrequant_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "mplayer_name="))
            {
              strcpy (mplayer_name, &szParameter[13]);
              continue;
            }
            if (strncmp (szParameter, "mplex_name=", 11) == 0)
            {
              strcpy (mplex_name, &szParameter[11]);
              continue;
            }
            if (strstr (szParameter, "tcmplex_name="))
            {
              strcpy (tcmplex_name, &szParameter[13]);
              continue;
            }
            if (strstr (szParameter, "spumux_name="))
            {
              strcpy (spumux_name, &szParameter[12]);
              continue;
            }
            if (strstr (szParameter, "spuunmux_name="))
            {
              strcpy (spuunmux_name, &szParameter[14]);
              continue;
            }
            if (strstr (szParameter, "dvdbackup_name="))
            {
              strcpy (dvdbackup_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "dvdunauthor_name="))
            {
              strcpy (dvdunauthor_name, &szParameter[17]);
              continue;
            }
            if (strstr (szParameter, "vamps_name="))
            {
              strcpy (vamps_name, &szParameter[11]);
              continue;
            }
            if (strstr (szParameter, "tcprobe_name="))
            {
              strcpy (tcprobe_name, &szParameter[13]);
              continue;
            }
            if (strstr (szParameter, "mkisofs_name="))
            {
              strcpy (mkisofs_name, &szParameter[13]);
              continue;
            }
            if (strstr (szParameter, "cdrecord_prodvd_name="))
            {
              strcpy (cdrecord_prodvd_name, &szParameter[21]);
              continue;
            }
            if (strstr (szParameter, "growisofs_name="))
            {
              strcpy (growisofs_name, &szParameter[15]);
              continue;
            }
            if (strstr (szParameter, "eject_name="))
            {
              strcpy (eject_name, &szParameter[11]);
              continue;
            }
            if (strstr (szParameter, "eject="))
            {
              strcpy (szDummy, &szParameter[6]);
              lEject=atol(szDummy);
              continue;
            }
            if (strstr (szParameter, "dvd+rw-format="))
            {
              strcpy (dvdformat_name, &szParameter[14]);
              continue;
            }
            if (strstr (szParameter, "rw-format="))
            {
              strcpy (szDummy, &szParameter[10]);

              lRWFormat=atol(szDummy);
              continue;
            }
          }
          fclose (fConf);
        }

        // Einstellungen koennen per Kommandozeile ueberschrieben werden
        if (argc >= 2)
        {
          char szDummy[255];
          char szParameter[255];
          long lParam;
          for (lParam=2; lParam <= argc; lParam++)
          {
            strcpy (szParameter, argv[lParam-1]);
            if (strncmp (szParameter, "-t=", 3) == 0)
            {
              strcpy (szDummy, &szParameter[3]);
              opt_t=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-a=", 3) == 0)
            {
              strcpy (szZusatzSprache, "");
              strncpy (szDummy, &szParameter[3], 1);
              szDummy[1] = 0;
              if (strcmp (szDummy, "l") == 0) strcpy (szDummy, "5"); // Auswahl per Liste
              lSprachAuswahl=atol(szDummy);
              if (lSprachAuswahl == 4)
              {
                strcpy (szZusatzSprache, &szParameter[5]);
              }
              continue;
            }
            if (strncmp (szParameter, "-u=", 3) == 0)
            {
              strcpy (szDummy, &szParameter[3]);
              if ( (strlen (szDummy) == 2) &&
                   (szDummy[0] < '0' || szDummy[0] > '9')
                 )
              {
                strcpy (szUntertitelSprache, szDummy);
                lUntertitel = -2;
              } else
              {
                if (szDummy[0] == 'l')
                  lUntertitel = -1;  // Auwahl per Liste
                else
                  lUntertitel=atol(szDummy);
              }
              continue;
            }
            if (strncmp (szParameter, "-f=", 3) == 0)
            {
              strcpy (szDummy, &szParameter[3]);
              dFaktor=atof(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-dl=", 4) == 0)
            {
              strcpy (dvd_device, &szParameter[4]);
              continue;
            }
            if (strncmp (szParameter, "-db=", 4) == 0)
            {
              strcpy (szDVDBrenner, &szParameter[4]);
              continue;
            }
            if (strncmp (szParameter, "-file=", 6) == 0)
            {
              strcpy (szOutputFile, &szParameter[6]);
              continue;
            }
            if (strncmp (szParameter, "-fv=", 4) == 0)
            {
              strcpy (szFilmVerzeichnis, &szParameter[4]);
              continue;
            }
            if (strncmp (szParameter, "-bp=", 4) == 0)
            {
              strcpy (szDummy, &szParameter[4]);
              lBrennProgramm=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-chap=", 6) == 0)
            {
              strcpy (szDummy, &szParameter[6]);
              lMitKapiteln=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-vp=", 4) == 0)
            {
              strcpy (szVOBPlayer, &szParameter[4]);
              continue;
            }
            if (strncmp (szParameter, "-lang=", 6) == 0)
            {
              if (strcmp (&szParameter[6], "en") == 0) lSprache = 1;
              continue;
            }
            if (strncmp (szParameter, "-ad=", 4) == 0)
            {
              strcpy (szDummy, &szParameter[4]);
              lAudioDefault=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-free=", 6) == 0)
            {
              strcpy (szDummy, &szParameter[6]);
              lTestFree=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-st=", 4) == 0)
            {
              if (strcmp (&szParameter[4], "streamdvd") == 0) lPackMethode = 1;
              if (strcmp (&szParameter[4], "trans_par") == 0) lPackMethode = 2;
              if (strcmp (&szParameter[4], "mplayer") == 0) lPackMethode = 3;
              if (strcmp (&szParameter[4], "transcode") == 0) lPackMethode = 4;
              if (strcmp (&szParameter[4], "copy") == 0) lPackMethode = 5;
              continue;
            }
            if (strncmp (szParameter, "-wb=", 4) == 0)
            {
              strcpy (szDummy, &szParameter[4]);
              lWaitBurn=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-tmp=", 5) == 0)
            {
              strcpy (szTmpDir, &szParameter[5]);
              continue;
            }
            if (strncmp (szParameter, "-d=", 3) == 0)
            {
              strcpy (szDummy, &szParameter[3]);
              lLoeschen=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-format=", 8) == 0)
            {
              strcpy (szDummy, &szParameter[8]);
              lRWFormat=atol(szDummy);
              continue;
            }
            if (strncmp (szParameter, "-mp=", 4) == 0)
            {
              if (strcmp (&szParameter[4], "tcmplex") == 0) lMultiplexer = 1;
              if (strcmp (&szParameter[4], "mplex") == 0) lMultiplexer = 2;
              continue;
            }
            if (strncmp (szParameter, "-lab=", 5) == 0) // Volume-ID / Label
            {
              strcpy (szDVDNameOverwrite, &szParameter[5]);
              continue;
            }
            if (strncmp (szParameter, "-debug=", 7) == 0)
            {
              strcpy (szDummy, &szParameter[7]);
              lDebugLevel=atol(szDummy);
              continue;
            }
            if (strcmp (szParameter, "-h") == 0 ||
                strcmp (szParameter, "--help") == 0
               )
            {
              lShowHelp = 1;
              continue;
            }
            if (strcmp (szParameter, "-v") == 0 ||
                strcmp (szParameter, "--version") == 0
               )
            {
              if (lSprache == 0)
              {
                printf ("\nlxdvdrip Version %s.\n\nHilfe mit 'lxdvdrip -h'\n", VERSION);
                if (strlen (szConfigVersion)) 
                  printf ("Version von /etc/lxdvdrip.conf: %s\n", szConfigVersion);
                printf ("\nVerwendete Programme:\n\n");
              } else
              {
                printf ("\nlxdvdrip Version %s.\n\nHelp with 'lxdvdrip -h'\n", VERSION);
                if (strlen (szConfigVersion)) 
                  printf ("Version from /etc/lxdvdrip.conf: %s\n", szConfigVersion);
              }
              printf ("%s\n", dvdauthor_name);
              printf ("%s\n", streamdvd_name);
              printf ("%s\n", streamanalyze_name);
              printf ("%s\n", buffer_name);
              printf ("%s\n", tccat_name);
              printf ("%s\n", tcextract_name);
              printf ("%s\n", tcrequant_name);
              printf ("%s\n", mplayer_name);
              printf ("%s\n", mplex_name);
              printf ("%s\n", tcmplex_name);
              printf ("%s\n", spumux_name);
              printf ("%s\n", spuunmux_name);
              printf ("%s\n", dvdbackup_name);
              printf ("%s\n", dvdunauthor_name);
              printf ("%s\n", vamps_name);
              printf ("%s\n", tcprobe_name);
              printf ("%s\n", mkisofs_name);
              printf ("%s\n", cdrecord_prodvd_name);
              printf ("%s\n", growisofs_name);
              printf ("%s\n", dvdformat_name);
              printf ("%s\n\n", eject_name);
              return 0;
            }
            // Parameter ist nicht zu verarbeiten, Abbruch
            if (lSprache == 0)
              printf ("\nDer Parameter '%s' ist unbekannt, bitte ueberpruefen!\n\n", szParameter);
            else
              printf ("\nThe parameter '%s' is unknown!\n\n", szParameter);
            return 0;
          }
        }

        // Hilfe anzeigen ?
        if (lShowHelp)
        {
          if (lSprache == 0)
          {
            // Hilfe auf deutsch
            printf ("Hilfe zu lxdvdrip %s\n", VERSION);
            printf ("======================\n\n");
            printf ("Aufruf: lxdvdrip [-parameter=wert]\n\n");
            printf ("Es muessen nur Parameter angegeben werden, die anders gesetzt sind als Standard\n");
            printf ("oder in der config-Datei (/etc/lxdvdrip.conf).\n");
            printf ("Die Voreinstellung steht in Klammern hintern jedem Parameter.\n\n");
            printf ("-st=Streamtool       : streamdvd, mplayer, transcode, trans_par (Transcode\n");
            printf ("                       parallel), dvdbackup (-st=streamdvd)\n");
            printf ("-mp=mplex            : Multiplexer, nur bei -st=mplayer beruecksichtigt,\n");
            printf ("                       alternativ mplex auswaehlbaer bei Problemen mit tcmplex\n");
            printf ("                       (-mp=tcmplex)\n");
            printf ("-tmp=Verzeichnis     : Verzeichnis fuer temp-Dateien beim Rippen mit mplayer\n");
            printf ("                       (-tmp=/tmp)\n");
            printf ("-t=TitelNr           : Nr des zu rippenden Titels, bestimmen mit \"lsdvd\", in\n");
            printf ("                       der Regel der laengste Titel, 0=laengster Titel wird\n");
            printf ("                       berechnet (-t=0)\n");
            printf ("\nSeite 2: Enter druecken");
            eatToNL(stdin);
            printf ("-a=Sprachauswahl     : -a=1: nur deutsch, -a=2: nur englisch, -a=3: deutsch+\n");
            printf ("                       englisch, -a=4,xy in Sprache xy (z. B. it fuer\n");
            printf ("                       italienisch), -a=l fuer freie Audiotrackauswahl per Liste\n");
            printf ("                       (-a=1)\n");
            printf ("-ad=AudioDefault     : 0=erster passender Track in Sprache, 1=AC3 mit 6 Kanal\n");
            printf ("                       vor AC3/2, 2=DTS zuerst (-ad=0)\n");
            printf ("-lab=VolumeID        : Name der DVD (Volume-ID/Label)\n");
            printf ("-chap=Mit Kapiteln   : 0=ohne Kapitel, 1=mit Kapiteln (-chap=1)\n");
            printf ("-u=Untertitel-Nr     : Nr des zu rippenden Untertitels (Infos ueber lsdvd),\n"); 
            printf ("                       0=ohne Untertitel, l=Anzeige Liste, auswaehlen, \n");
            printf ("                       alternativ Sprache, z. B. \"-u=de\" (-u=0)\n");
            printf ("-fv=Film_Verzeichnis : Verzeichnis, wo die gerippten Daten abgelegt werden\n");
            printf ("                       (-fv=/tmp/film-dvd)\n");
            printf ("-f=Faktor            : Faktor wird selbst berechnet im Normalfall, hier kann\n"); 
            printf ("                       jedoch auch ein anderer Wert gesetzt werden, bei \"-f=-1\"\n"); 
            printf ("                       erfolgt Testrip eines Kapitels, \"-f=-2\" => streamanalyze\n");
            printf ("                       (-f=0)\n");
            printf ("-dl=DVD-Device       : Device-Name des DVD-Leselaufwerkes (-dl=/dev/dvd)\n");
            printf ("-db=Brenner-Device   : Device fuer Brenner (-db=/dev/scd0)\n");
            printf ("\nSeite 3: Enter druecken");
            eatToNL(stdin);
            printf ("-bp=Brenn-Programm   : 1=growisofs, 2=cdrecord-prodvd, 3=cdrecord-prodvd on the\n"); 
            printf ("                       fly, 0=kein Brennen (-bp=1)\n");
            printf ("-format=             : 1=RW formatieren, 0=RW nicht formatieren (-format=0)\n");
            printf ("-wb=Frage vor Brennen: Sicherheitsabfrage, Rohling einlegen vor Brennen \n");
            printf ("                       (1=ja, 0=nein) (-wb=1)\n");
            printf ("-vp=VOB-Player       : Medienplayer fuer Vorschau, off=keine Vorschau\n"); 
            printf ("                       (-vp=mplayer)\n");
            printf ("-lang=en             : Umschalten auf englische Sprache\n");
            printf ("-d=loeschen          : Am Ende Film-Verzeichnis loeschen (0=nein, 1=ja) (-d=1)\n");
            printf ("-free=Testen?        : Pruefe auf freien Plattenplatz vorm Rippen (0=nein, 1=ja)\n");
            printf ("                       (-free=1)\n");
            printf ("-file=Ausgabedatei   : Statt dvdauthor+Brennen Ergebnis als Datei, z. B.\n");
            printf ("                       \"-file=/tmp/dvd.vob\"\n");
            printf ("-h                   : Diese Hilfe zeigen (ebenso --help)\n");
            printf ("-v                   : Version ausgeben (ebenso --version)\n");
            printf ("Beispiel: # lxdvdrip -t=1\n");
            printf ("Falls jeweils 2 Audiospuren fuer eine Sprache vorhanden sind (Bsp: deutsch)\n");
            printf ("in ac3 und dts, wird als Standard die dts-Spur genommen, da Qualitaet besser\n"); 
            printf ("(Option: -ad=2). Bei 2 AC3-Spuren wird die mit der hoeheren Kanalzahl verwendet\n");
            printf ("(Option -ad=1).\n");
          } else
          {
            // english Help Text
            printf ("lxdvdrip %s Help\n", VERSION);
            printf ("==================\n\n");
            printf ("Start Program: lxdvdrip [-parameter=value]\n\n");
            printf ("You need only to give those parameters with different values as defined in the\n"); 
            printf ("config-file (/etc/lxdvdrip.conf).\n");
            printf ("The default values are printed in brackets () behind the parameters.\n\n");
            printf ("-st=Streamtool       : streamdvd, mplayer, transcode, trans_par (Transcode\n"); 
            printf ("                       parallel), dvdbackup (-st=streamdvd)\n");
            printf ("-mp=mplex            : Multiplexer, only with -st=mplayer, use mplex instead of\n"); 
            printf ("                       tcmplex when having problems with tcmplex (-mp=tcmplex)\n");
            printf ("-tmp=Directory       : Directory for temporary files for ripping with mplayer\n");
            printf ("                       (-tmp=/tmp)\n");
            printf ("-t=TitleNr           : Nr of the ripping title, \"lsdvd\" shows all titles, \n");
            printf ("                       normally the longest title, 0=longest title will be \n");
            printf ("                       calculated by lxdvdrip (-t=0)\n");
            printf ("\nPage 2: Please press Enter\n");
            eatToNL(stdin);
            printf ("-a=Audio language    : -a=1: german only, -a=2: english only, -a=3: german+\n");
            printf ("                       english, -a=4,xy in language xy, i. E. -a=4,f for french\n");
            printf ("                       -a=l for list with free selection of audiotracks (-a=1)\n");
            printf ("-ad=AudioDefault     : 0=first track in chosen language, 1=AC3 with 6 channels \n");
            printf ("                       preferred to AC3/2, 2=DTS first (-ad=0)\n");	
            printf ("-lab=VolumeID        : Name of DVD (Volume-ID/Label)\n");
            printf ("-chap=chapter        : 0=without chapters, 1=with chapters (-chap=1)\n");
            printf ("-u=Subpicture-Nr.    : Nr of the ripping Subpicture-Track (infos with lsdvd), \n");
            printf ("                       0=without subtitles, l=lxdvdrip shows list, input, \n");
            printf ("                       alternative language, i. E. \"-u=de\" (-u=0)\n");
            printf ("-fv=Film-Directory   : Directory for the ripping files (-fv=/tmp/film-dvd)\n");
            printf ("-f=Factor            : Normally factor for requant will be calculated, but you \n");
            printf ("                       can overwrite the factor with your value, with \"-f=-1\"\n");
            printf ("                       lxdvdrip makes a testrip of one chapter to calculate \n");
            printf ("                       factor, \"-f=-2\" => streamanalyze (-f=0)\n");
            printf ("-dl=DVD-Device       : Device-Name of DVD-Reader (-dl=/dev/dvd)\n");
            printf ("-db=Burner-Device    : Device of the Burner (-db=/dev/scd0)\n");
            printf ("-bp=Burn-Program     : 1=growisofs, 2=cdrecord-prodvd, 3=cdrecord-prodvd on the\n");
            printf ("                       fly, 0=no Burning (-bp=1)\n");
            printf ("\nPage 3: Please press Enter\n");
            eatToNL(stdin);
            printf ("-wb=Wait for Burn    : Program asks you for DVD-R before burning (1=yes, 0=no)\n");
            printf ("                       (-wb=1)\n");
            printf ("-format=             : 1=RW format, 0=no (-format=0)\n");
            printf ("-vp=VOB-Player       : player for VOB-preview, off=no preview (-vp=mplayer)\n");
            printf ("-lang=en             : Program in english (Default german)\n");
            printf ("-d=delete            : Delete VOB-Files after burning (0=no, 1=yes) (-d=1)\n");
            printf ("-free=check          : Check for free disk space before ripping (0=no, 1=yes)\n");
            printf ("                       (-free=1)\n");
            printf ("-file=Outputfile     : Instead of dvdauthor+growisofs write result in a file, \n");
            printf ("                       i. E. \"-file=/tmp/dvd.vob\"\n");
            printf ("-h                   : Show this help (--help)\n");
            printf ("-v                   : Show version (--version)\n");
            printf ("Example: # lxdvdrip -t=1\n");
            printf ("If there are 2 audio tracks in the same language, lxdvdrip takes the dts-track\n"); 
            printf ("as default (better quality, option to use: -ad=2). If there are 2 AC3-tracks,\n"); 
            printf ("lxdvdrip takes that one with the highest number of channels (Option -ad=1).\n");
          }
          return 0;
        }

        if (lSprache == 0)
        {
          printf ("Das Programm startet mit folgenden Einstellungen:\n\n");
          printf ("Sprache:       %ld (0=deutsch,1=englisch)\n", lSprache);
          printf ("Streamtool:    %ld (1=streamdvd, 2=transcode parallel, 3=mplayer, 4=transcode, 5=dvdbackup)\n", lPackMethode);
          printf ("Multiplexer:   %ld (1=tcmplex, 2=mplex)\n", lMultiplexer);
          printf ("Tmp-Dir:       %s\n", szTmpDir);
          printf ("Titel:         %ld (0=laengsten Titel selbst bestimmen)\n", (long)opt_t);
          printf ("Audio-Track:   %ld/%s (1=deutsch, 2=englisch, 3=deutsch+englisch, 4=extra Sprache waehlen, 5=Tracks eingeben)\n", lSprachAuswahl, szZusatzSprache);
          printf ("AudioDefault:  %ld (0=erster passender Track in Sprache, 1=AC3 mit 6 Kanal vor AC3/2, 2=DTS zuerst)\n", lAudioDefault);	
          if (!strlen (szUntertitelSprache))
            printf ("Untertitel:    %ld (Titel-Nr, 0=keine Untertitel, -1=Liste)\n", lUntertitel);
          else
            printf ("Untertitel:    %s\n", szUntertitelSprache);
          printf ("Kapitel:       %ld (0=nein, 1=ja)\n", lMitKapiteln);
          printf ("Verzeichnis:   %s (Verzeichnis fuer Film, z. B. /tmp/film-dvd)\n", szFilmVerzeichnis);
          printf ("Files loeschen:%ld (0=nein, 1=ja)\n", lLoeschen);
          printf ("Faktor:        %f\n", dFaktor);
          printf ("DVD-Leser:     %s (Device-Name)\n", dvd_device);
          if (!strlen(szOutputFile))
          {
            printf ("DVD-Brenner:   %s (Device-Name)\n", szDVDBrenner);
            printf ("Brennprogramm: %ld (1=growisofs, 2=cdrecord-prodvd, 3=cdrecord-prodvd on the fly, 0=nicht brennen)\n", lBrennProgramm);
            printf ("RW formatieren:%ld (0=nein, 1=ja)\n", lRWFormat);
            printf ("Warte auf DVDR:%ld (1=ja, 0=nein)\n", lWaitBurn);
            printf ("VOB-Player:    %s (Name des Players fuer Vorschau, Standard mplayer, off=keine Vorschau)\n", szVOBPlayer);
            printf ("DVDSpeed:      %ld\n", lDVDSpeed);
            printf ("cdrecord-key:  %s\n", szCDRSecurity);
          } else
          {
            printf ("Ausgabe in Datei: %s\n", szOutputFile);
          } 
          if (lDebugLevel)
          {
            printf ("Debug-Level:   %ld\n", lDebugLevel);
          }  
        } else
        {
          printf ("Starting with these settings:\n\n");
          printf ("Language       %ld (0=german,1=english)\n", lSprache);
          printf ("Streamtool:    %ld (1=streamdvd, 2=transcode parallel, 3=mplayer,4=transcode, 5=dvdbackup)\n", lPackMethode);
          printf ("Multiplexer:   %ld (1=tcmplex, 2=mplex)\n", lMultiplexer);
          printf ("Tmp-Dir:       %s\n", szTmpDir);
          printf ("Title:         %ld (0=calculate longest title)\n", (long)opt_t);
          printf ("Audio-Track:   %ld/%s (1=german, 2=english, 3=german+english, 4=select other language, 5=input title Nr.)\n", lSprachAuswahl, szZusatzSprache);
          printf ("AudioDefault:  %ld (0=first track in chosen language, 1=AC3 with 6 channels preferred to AC3/2, 2=DTS first)\n", lAudioDefault);	
          if (!strlen (szUntertitelSprache))
            printf ("Subpicture:    %ld (Subpicture-Track-No, 0=no subpictures, -1=list)\n", lUntertitel);
          else
            printf ("Subpicture:    %s\n", szUntertitelSprache);
          printf ("Chapter:       %ld (0=no, 1=yes)\n", lMitKapiteln);
          printf ("Directory:     %s (Directory for film, i. e. /tmp/film-dvd)\n", szFilmVerzeichnis);
          printf ("Files delete:  %ld (0=no, 1=yes)\n", lLoeschen);
          printf ("Factor:        %f\n", dFaktor);
          printf ("DVD-Reader:    %s (Device-Name)\n", dvd_device);
          if (!strlen(szOutputFile))
          {
            printf ("DVD-Burner:    %s (Device-Name)\n", szDVDBrenner);
            printf ("Burn-Prog:     %ld (1=growisofs, 2=cdrecord-prodvd, 3=cdrecord-prodvd on the fly, 0=no burning)\n", lBrennProgramm);
            printf ("RW format:     %ld (0=no, 1=yes)\n", lRWFormat);
            printf ("Wait for DVDR: %ld (1=yes, 0=no)\n", lWaitBurn);
            printf ("VOB-Player:    %s (Name of player for preview, default: mplayer, off=no preview)\n", szVOBPlayer);
            printf ("DVDSpeed:      %ld\n", lDVDSpeed);
            printf ("cdrecord-key:  %s\n", szCDRSecurity);
          } else
          {
            printf ("Result in a File: %s\n", szOutputFile);
          } 
          if (lDebugLevel)
          {
            printf ("Debug-Level:   %ld\n", lDebugLevel);
          }  
        }

        if (strlen(szOutputFile) && (lPackMethode==5 || lPackMethode==2))
        {
          if (lSprache==0)
            printf ("\nAusgabe in Datei nicht bei dvdbackup oder Transcode parallel!\n");
          else
            printf ("\nOutput to file not with dvdbackup or transcode parallel!\n");
          return 0;
        }

        if (lMultiplexer==1 && lPackMethode==2)
        {
          if (lSprache==0)
            printf ("\ntcmplex nicht bei transcode parallel, verwende mplex!\n");
          else
            printf ("\ntcmplex not with transcode parallel, using mplex!\n");
          lMultiplexer=2;
        }

        // Genug freier Speicherplatz im Fimverzeichnis ?
        // Basisverzeichnis fuer Dateiablage bilden
        if (lTestFree)
        {
          char szMainDir[1024];
          long lFrei = 1;
          int lfn=1;
          szMainDir[0] = 0;
          if (lSprache == 0)
            printf ("\nPruefe auf freien Plattenplatz: ...\n");
          else
            printf ("\nChecking free disk space: ...\n");
          if (szFilmVerzeichnis[0] == '/')
          {
            strcpy (szMainDir, "/");
          } else
          {
            strncpy (szMainDir, &szFilmVerzeichnis[0], 1);
          }
          while (1==1)
          {
            if (strlen (szFilmVerzeichnis) < lfn) break;
            if (szFilmVerzeichnis[lfn] == '/') break;
            strncat (szMainDir, &szFilmVerzeichnis[lfn], 1);
            lfn++;
          }
          if (calculate_discfree (szMainDir, lSprache) < lGroesseDVDBytesMaximal)
          {
            char cContinue=' ';
            lFrei = 0;
            if (lSprache == 0)
              printf ("Zuwenig freier Speicherplatz im Verzeichnis %s zum Backup der DVD! (Weiter mit 'j')\n", szMainDir);
            else
              printf ("Not enough free disk space in %s to backup the DVD! (Continue with 'y')\n", szMainDir);
            scanf ("%c", &cContinue);
            if (cContinue != 'y' && cContinue != 'j')
            {
              return 0;
            }
          }
  
          // Bei Packmethode 3 (mplayer), 4 (transcode) muss der doppelte Platz frei sein
          if (lPackMethode == 3 || lPackMethode == 4)
          {
            long long lFaktor = 1;
            // TmpDir und FilmDir im gleichen Verzeichnis, dann muss doppelt freier Platz sein
            if (device_number (szMainDir) == device_number (szTmpDir))
            {
              lFaktor = 2;
            }
            if (calculate_discfree (szTmpDir, lSprache) < (lGroesseDVDBytesMaximal*lFaktor))
            {
              char cContinue=' ';
              lFrei = 0;
              if (lSprache == 0)
                printf ("Zuwenig freier Speicherplatz im Verzeichnis %s zum Backup der DVD! (Weiter mit 'j')\n", szTmpDir);
              else
                printf ("Not enough free disk space in %s to backup the DVD! (Continue with 'y')\n", szTmpDir);
              scanf ("%c", &cContinue);
              if (cContinue != 'y' && cContinue != 'j')
              {
                return 0;
              }
            }
          }
          if (lFrei)
          {
            printf ("Test OK\n");
          }
        }

          
	ret = stat(dvd_device, &dvd_stat);
	if ( ret < 0 ) {
		fprintf(stderr, "Can't find device %s\n", dvd_device);
		return 1;
	}
	
	dvd = DVDOpen(dvd_device);
	if( !dvd ) {
		fprintf( stderr, "Can't open disc %s!\n", dvd_device);
		return 2;
	}
	ifo_zero = ifoOpen(dvd, 0);
	if ( !ifo_zero ) {
                fprintf( stderr, "Can't open main ifo!\n");
		return 3;
	}

	ifo = (ifo_handle_t **)malloc((ifo_zero->vts_atrt->nr_of_vtss + 1) * sizeof(ifo_handle_t *));

	for (i=1; i <= ifo_zero->vts_atrt->nr_of_vtss; i++) {
		ifo[i] = ifoOpen(dvd, i);
		if ( !ifo[i] ) {
			fprintf( stderr, "Can't open ifo %d!\n", i);
			return 4;
		}
	}

	titles = ifo_zero->tt_srpt->nr_of_srpts;

	if ( opt_t > titles || opt_t < 0) {
		fprintf (stderr, "Only %d titles on this disc!", titles);
		return 5;
	}

        has_title = get_title_name(dvd_device, title, lSprache);

	vmgi_mat = ifo_zero->vmgi_mat;

	if (opt_p) {
		START;
		DEF("device", "'%s'", dvd_device);
		DEF("title", "'%s'", has_title ? "unknown" : title);
		DEF("vmg_id", "'%.12s'", vmgi_mat->vmg_identifier);
		DEF("provider_id", "'%.32s'", vmgi_mat->provider_identifier);
	
		ARRAY("track");
	} else {
		printf("Disc Title: %s\n", has_title ? "unknown" : title);
                // Titel uebernehmen fuers Image, wird dann der DVD-Titel am Player
                if (has_title == 0 && !strlen (szDVDName))
                {
                  strcpy (szDVDName, title);
                }
	}

        // Fragment aus dvdbackup, Inhalt der Original DVD auflisten
	title_set_info = DVDGetFileSet(dvd);
	if (title_set_info) {
  	  fprintf(stdout,"File Structure DVD\n");
    	  fprintf(stdout,"VIDEO_TS/\n");
  	  fprintf(stdout,"\tVIDEO_TS.IFO\t%i\n", title_set_info->title_set[0].size_ifo);
          lGroesseDVDGesamt += (long long)title_set_info->title_set[0].size_ifo;
  	  if (title_set_info->title_set[0].size_menu != 0 ) {
		fprintf(stdout,"\tVIDEO_TS.VOB\t%i\n", title_set_info->title_set[0].size_menu);
                lGroesseDVDGesamt += (long long)title_set_info->title_set[0].size_menu;
 	  }
  	  fprintf(stdout,"\tVIDEO_TS.BUP\t%i\n", title_set_info->title_set[0].size_bup);
	  for( i = 0 ; i < title_set_info->number_of_title_sets ; i++) {
		fprintf(stdout,"\tVTS_%02i_0.IFO\t%i\n", i + 1, title_set_info->title_set[i + 1].size_ifo);
                lGroesseDVDGesamt += (long long)title_set_info->title_set[i + 1].size_ifo;
		if (title_set_info->title_set[i + 1].size_menu != 0 ) {
			fprintf(stdout,"\tVTS_%02i_0.VOB\t%i\n", i + 1, title_set_info->title_set[i + 1].size_menu);
                        lGroesseDVDGesamt += (long long)title_set_info->title_set[i + 1].size_menu;
		}
		if (title_set_info->title_set[i + 1].number_of_vob_files != 0) {
                        int f;
			for( f = 0; f < title_set_info->title_set[i + 1].number_of_vob_files ; f++ ) {
				fprintf(stdout,"\tVTS_%02i_%i.VOB\t%i\n", i + 1, f + 1, title_set_info->title_set[i + 1].size_vob[f]);
                                lGroesseDVDGesamt += (long long)title_set_info->title_set[i + 1].size_vob[f];
			}
		}
		fprintf(stdout,"\tVTS_%02i_0.BUP\t%i\n", i + 1, title_set_info->title_set[i + 1].size_bup);
                lGroesseDVDGesamt += (long long)title_set_info->title_set[i + 1].size_bup;
  	  }
	  DVDFreeTitleSetInfo(title_set_info);
        
          if (lSprache==0)
            printf ("\n\nGesamtgroesse der DVD: %lld Bytes\n", lGroesseDVDGesamt);
          else
            printf ("\n\nTotal size: %lld Bytes\n", lGroesseDVDGesamt);
        } else
        { 
          // Struktur nicht zu lesen, vermutlich Rippen von Festplatte. Daher 5 GB als Groesse
          lGroesseDVDGesamt = 50 * (long long)100000000;
        }

        // Wenn DVD kleiner als 4,7 GB, erfolgt Kopie ueber DVD Backup
        if ( (lGroesseDVDGesamt < lGroesseDVDBytesMaximal) && (lPackMethode != 5) )
        {
          char szPacken[128];
          if (lSprache==0)
            printf ("\nDie DVD passt auf einen Rohling, soll dvdbackup zum Rippen verwendet werden (j/n) ?\n\n");
          else
            printf ("\nThe DVD is smaller than a DVD-R, use dvdbackup to read DVD (y/n) ?\n\n");
          scanf ("%s", szPacken);
          eatToNL(stdin);
          if (szPacken[0] == 'j' || szPacken[0] == 'y')
          {
            lPackMethode = 5; // dvdbackup
          }
        }

        if (lPackMethode == 5) // DVD-Backup
        {
          lUntertitel=1;
          lPaletteVorhanden = 1;
          j = 0;
          // Palettenfile fuer Untertitel, wird bei copy-Modus benoetigt
          vtsi_mat   = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vtsi_mat;
          vts_pgcit  = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vts_pgcit;
          video_attr = &vtsi_mat->vts_video_attr;
          vts_ttn = ifo_zero->tt_srpt->title[j].vts_ttn;
          vmgi_mat = ifo_zero->vmgi_mat;
          title_set_nr = ifo_zero->tt_srpt->title[j].title_set_nr;
          pgc = vts_pgcit->pgci_srp[ifo[title_set_nr]->vts_ptt_srpt->title[vts_ttn - 1].ptt[0].pgcn - 1].pgc;
          {
            FILE * fp;
            mkstemp(szPaletteFile);
            fp=fopen(szPaletteFile, "w");
            for (i=0; i<16; i++)
              fprintf(fp, "%06x\n", pgc->palette[i]);
            fclose (fp);
          }
  	  ifoClose(ifo_zero);
	  DVDClose(dvd);
          strcpy (szVideoTS, "VIDEO_TS");
          strcpy (szAudioTS, "AUDIO_TS");
          strcpy (szVobTS, "VOB");
          strcpy (szVtsTS, "VTS");
        } else
        {

        // Berechne den laengsten Track
	for (j=0; j < titles; j++)
	{
          vtsi_mat   = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vtsi_mat;
          vts_pgcit  = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vts_pgcit;
          video_attr = &vtsi_mat->vts_video_attr;
          vts_ttn = ifo_zero->tt_srpt->title[j].vts_ttn;
          vmgi_mat = ifo_zero->vmgi_mat;
          title_set_nr = ifo_zero->tt_srpt->title[j].title_set_nr;
          pgc = vts_pgcit->pgci_srp[ifo[title_set_nr]->vts_ptt_srpt->title[vts_ttn - 1].ptt[0].pgcn - 1].pgc;

          if (dvdtime2msec(&pgc->playback_time) > max_length)
          {
            max_length = dvdtime2msec(&pgc->playback_time);
            max_track = j+1;
          }
	}

        // Wenn Titel nicht per Parameter gesetzt, verwende den laengsten Titel
        if (!opt_t)
        {
          opt_t = max_track;
        }

	for (j=0; j < titles; j++)
	{

	if ( opt_t == j+1 || opt_t == 0 ) {
	// GENERAL
	if (ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vtsi_mat) {

		vtsi_mat   = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vtsi_mat;
		vts_pgcit  = ifo[ifo_zero->tt_srpt->title[j].title_set_nr]->vts_pgcit;
		video_attr = &vtsi_mat->vts_video_attr;
		vts_ttn = ifo_zero->tt_srpt->title[j].vts_ttn;
		vmgi_mat = ifo_zero->vmgi_mat;
		title_set_nr = ifo_zero->tt_srpt->title[j].title_set_nr;
		//pgc = vts_pgcit->pgci_srp[ifo_zero->tt_srpt->title[j].vts_ttn - 1].pgc;
		//printf ("this pgcn = %i", ifo[title_set_nr]->vts_ptt_srpt->title[vts_ttn - 1].ptt[0].pgcn - 1);
		pgc = vts_pgcit->pgci_srp[ifo[title_set_nr]->vts_ptt_srpt->title[vts_ttn - 1].ptt[0].pgcn - 1].pgc;

		if (opt_p) {
 			HASH(0);
			DEF("ix", "%d", j+1);
			DEF("length", "%.3f", dvdtime2msec(&pgc->playback_time)/1000.0);
			DEF("vts_id", "'%.12s'", vtsi_mat->vts_identifier);
		} else {
                        char szTmp[128];
                        lAnzahlSekunden = 0;
			if (lDebugLevel) printf("Title: %02d, Length: %02x:%02x:%02x ", j+1, pgc->playback_time.hour, pgc->playback_time.minute, pgc->playback_time.second);
                        // Zeit ist in Hex gespeichert, hier umrechnen
                        sprintf (szTmp, "%02x", pgc->playback_time.hour);
                        lAnzahlSekunden += atol (szTmp)*3600;
                        sprintf (szTmp, "%02x", pgc->playback_time.minute);
                        lAnzahlSekunden += atol (szTmp)*60;
                        sprintf (szTmp, "%02x", pgc->playback_time.second);
                        lAnzahlSekunden += atol (szTmp);
		}

		if (! opt_q && ! opt_p) {
		if (lDebugLevel) printf("Chapters: %02d, Cells: %02d, ", ifo_zero->tt_srpt->title[j].nr_of_ptts, pgc->nr_of_cells);
                lAnzahlKapitel = ifo_zero->tt_srpt->title[j].nr_of_ptts;
		if (lDebugLevel) printf("Audio streams: %02d, Subpictures: %02d", vtsi_mat->nr_of_vts_audio_streams, vtsi_mat->nr_of_vts_subp_streams);
                lAnzahlAudioStreams = vtsi_mat->nr_of_vts_audio_streams;
		}

		if (! opt_p) { if (lDebugLevel) printf("\n"); }

                // Bei Untertiteln die Palette der DVD in eine Datei schreiben,
                // wird spaeter an dvdauthor weitergegeben
                strcpy (szPaletteOptions, "");
                if (lUntertitel != 0)
                {
                  FILE * fp;
                  mkstemp(szPaletteFile);
                  fp=fopen(szPaletteFile, "w");
                  for (i=0; i<16; i++)
		    fprintf(fp, "%06x\n", pgc->palette[i]);
                  fclose (fp);
                  lPaletteVorhanden=1;
                  sprintf (szPaletteOptions, " -p %s ", szPaletteFile);
                }

		// ANGLES
		if (opt_n) {
		if (opt_p) {	
			DEF("angles", "%d", ifo_zero->tt_srpt->title[j].nr_of_angles);
		} else {
	                if (lDebugLevel) printf("\tNumber of angles: %d\n", ifo_zero->tt_srpt->title[j].nr_of_angles);
		}
		}

		// AUDIO
		if (opt_a) {
		if (opt_p) {
			ARRAY("audio");
			for (i=0; i<vtsi_mat->nr_of_vts_audio_streams; i++)
			{
				audio_attr = &vtsi_mat->vts_audio_attr[i];
				sprintf(lang_code, "%c%c", audio_attr->lang_code>>8, audio_attr->lang_code & 0xff);
				if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
				HASH(0);
				DEF("ix", "%d", i+1);
				DEF("langcode", "'%s'", lang_code);
				DEF("language", "'%s'", lang_name(lang_code));
				DEF("format", "'%s'", audio_format[audio_attr->audio_format]);
				DEF("frequency", "%s", sample_freq[audio_attr->sample_frequency]);
				DEF("quantization", "'%s'", quantization[audio_attr->quantization]);
				DEF("channels", "%d", audio_attr->channels+1);
				DEF("ap_mode", "%d", audio_attr->application_mode);
				DEF("content", "'%s'", audio_type[audio_attr->lang_extension]);
				RETURN;
			}
			RETURN; 
		} else {
                        // Freie Auswahl der Audiotracks vorschalten
                        if (lSprachAuswahl == 5)
                        {
                          char szTrackSelect[128];
                          char szTrack1[128];
                          if (lSprache==0)
                            printf ("\nAuswahl von bis zu 2 Audiotracks:\n\n");
                          else
                            printf ("\nSelect 1 or 2 audiotracks:\n\n");
                          for (i=0; i<vtsi_mat->nr_of_vts_audio_streams; i++)
                	  {
                            audio_attr = &vtsi_mat->vts_audio_attr[i];
                            sprintf(lang_code, "%c%c", audio_attr->lang_code>>8, audio_attr->lang_code & 0xff);
                            if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
                            if (lSprache==0)
                              printf ("Track-Nr: %d, Sprache: %s, Format: %s, Kanaele: %d\n",
                                      i+1, lang_code, audio_format[audio_attr->audio_format], audio_attr->channels+1);
                            else
                              printf ("Track-No: %d, Language: %s, Format: %s, Channels: %d\n",
                                      i+1, lang_code, audio_format[audio_attr->audio_format], audio_attr->channels+1);
                          }    
                          // Track-Nr eingeben
                          if (lSprache==0)
                            printf ("\nWelche Tracks? Bsp: Fuer Track 1 und 3 muss \"1,3\" eingegeben werden !\n");
                          else
                            printf ("\nWhich tracks? I. E.: For track 1 and 3 you have to enter \"1,3\" !\n");
                          scanf ("%s", szTrackSelect);
                          eatToNL(stdin);
                          if (!strstr (szTrackSelect, ","))
                          {
                            lAudioTrackInput1 = atol (szTrackSelect);
                            lAudioTrackInput2 = 0;
                          }
                          for (i=0; i<strlen(szTrackSelect); i++)
                          {
                            if (szTrackSelect[i] != ',')
                              strncat (szTrack1, &szTrackSelect[i], 1);
                            else
                            {
                              lAudioTrackInput1 = atol (szTrack1);
                              lAudioTrackInput2 = atol (&szTrackSelect[i+1]);
                            }
                          }
                          if (lSprache==0)
                            printf ("\nGewaehlte Audiotracks: %d / %d\n", lAudioTrackInput1, lAudioTrackInput2);
                          else 
                            printf ("\nSelected audiotracks: %d / %d\n", lAudioTrackInput1, lAudioTrackInput2);
                          // Kein Track gewaehlt
                          if (lAudioTrackInput1 == 0 && lAudioTrackInput2 == 0)
                          {
                            if (lSprache==0)
                              printf ("\nKeine Audiotracks ausgewaehlt!\n");
                            else
                              printf ("\nNo audiotracks selected!\n");
                            ifoClose(ifo_zero);
                            DVDClose(dvd);
                            return 0;
                          }
                          // Track-Nr groesser als Nr. auf der DVD
                          if (lAudioTrackInput1 > vtsi_mat->nr_of_vts_audio_streams || 
                              lAudioTrackInput2 > vtsi_mat->nr_of_vts_audio_streams
                             )
                          {
                            if (lSprache==0)
                              printf ("\nNur %d Audiotracks auf der DVD!\n", vtsi_mat->nr_of_vts_audio_streams);
                            else
                              printf ("\nOnly %d audiotracks on the DVD!\n", vtsi_mat->nr_of_vts_audio_streams);
                            ifoClose(ifo_zero);
                            DVDClose(dvd);
                            return 0;
                          }
                          lLaengeInput1 = 0;
                          lLaengeInput2 = 0;
                          strcpy (szFormatInput1, "ac3");
                          strcpy (szFormatInput2, "ac3");
                          // Nochmals lesen und anhand der gewaehlten Nr. die Daten setzen
                          for (i=0; i<vtsi_mat->nr_of_vts_audio_streams; i++)
                	  {
                            char szLanguage[128];
                            long long lLaengeInput;
                            audio_attr = &vtsi_mat->vts_audio_attr[i];
                            sprintf (szLanguage, "%c%c", audio_attr->lang_code>>8, audio_attr->lang_code & 0xff);
                            if (!szLanguage[0]) { szLanguage[0] = 'x'; szLanguage[1] = 'x'; }
                            // Ueber Bitrate Groesse in Bytes berechnen
                            if (strstr (audio_format[audio_attr->audio_format], "ac3"))
                            {
                              if ((audio_attr->channels+1) == 2)
                                lLaengeInput = 128;
                              else
                                lLaengeInput = 384;
                            } else
                            {
                              if (strstr (audio_format[audio_attr->audio_format], "mpeg"))
                              {
                                lLaengeInput = 192; // mpeg1 hat 192 kbps
                              } else
                              {
                                lLaengeInput = 768; // sonst dts Groesse als Default
                              }
                            }
                            lLaengeInput = lLaengeInput/8*lAnzahlSekunden*1000;
                            lPlatzAudio += lLaengeInput;
                            if ((i+1) == lAudioTrackInput1)
                            {
                              strcpy (szFormatInput1, audio_format[audio_attr->audio_format]);
                              strcpy (szSpracheInput1, szLanguage);
                              lLaengeInput1 = lLaengeInput;
                              printf ("Groesse Audiotrack %ld: %lld Bytes\n", lAudioTrackInput1, lLaengeInput1);
                            }
                            if ((i+1) == lAudioTrackInput2)
                            {
                              strcpy (szFormatInput2, audio_format[audio_attr->audio_format]);
                              strcpy (szSpracheInput2, szLanguage);
                              lLaengeInput2 = lLaengeInput;
                              printf ("Groesse Audiotrack %ld: %lld Bytes\n", lAudioTrackInput2, lLaengeInput2);
                            }
                          }
                        } else
                        {   
  			  for (i=0; i<vtsi_mat->nr_of_vts_audio_streams; i++)
                	  {
                        	audio_attr = &vtsi_mat->vts_audio_attr[i];
                        	sprintf(lang_code, "%c%c", audio_attr->lang_code>>8, audio_attr->lang_code & 0xff);
	                        if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
		                if (lDebugLevel) printf("\tAudio: %d, Language: %s - %s, ", i +1 , lang_code, lang_name(lang_code));
       	                	if (lDebugLevel) printf("Format: %s, ", audio_format[audio_attr->audio_format]);
				if (lDebugLevel) printf("Frequency: %s, ", sample_freq[audio_attr->sample_frequency]);
                       		if (lDebugLevel) printf("Quantization: %s, ", quantization[audio_attr->quantization]);
                	        if (lDebugLevel) printf("Channels: %d, AP: %d, ", audio_attr->channels+1, audio_attr->application_mode);
                	        if (lDebugLevel) printf("Content: %s", audio_type[audio_attr->lang_extension]);
                        	if (lDebugLevel) printf("\n");
                                if (strcmp (audio_format[audio_attr->audio_format], "ac3") == 0)
                                {
                                  long lAudioKBPS;
                                  // Falls die gezogene Audiospur weniger Kanaele hat, jetzt diese auswaehlen.
                                  // Ebenso bei bereits gewaehltem DTS-Track, aber dts ausgeschaltet.
                                  if ( (lAudioTrackDeutsch && strcmp(lang_code, "de")==0 && lAnzahlChannelDeutsch < (audio_attr->channels+1) && lAudioDefault==1) ||
                                       (lAudioDefault==0 && strcmp(szAudioFormatDeutsch, "dts") == 0)
                                     )
                                  {
                                    lAudioTrackDeutsch = 0; // wird mit folgenden Abfragen neu gesetzt
                                  }
                                  if ( (lAudioTrackEnglisch && strcmp(lang_code, "en")==0 && lAnzahlChannelEnglisch < (audio_attr->channels+1) && lAudioDefault==1) ||
                                       (lAudioDefault==0 && strcmp(szAudioFormatEnglisch, "dts") == 0)
                                     )
                                  {
                                    lAudioTrackEnglisch = 0; // wird mit folgenden Abfragen neu gesetzt
                                  }
                                  if (lSprachAuswahl == 4)
                                  {
                                    if ( (lZusatzAudioTrack && strcmp(lang_code, szZusatzSprache)==0 && lZusatzAnzahlChannel < (audio_attr->channels+1) && lAudioDefault==1) ||
                                         (lAudioDefault==0 && strcmp(szZusatzAudioFormat, "dts") == 0)
                                       )
                                    {
                                      lZusatzAudioTrack = 0; // wird mit folgenden Abfragen neu gesetzt
                                    }
                                  }
                                  if ((audio_attr->channels+1) == 2) 
                                    lAudioKBPS = 128;
                                  else
                                    lAudioKBPS = 384;
                                  lPlatzAudio += (lAudioKBPS/8*lAnzahlSekunden*1000);
                                  if (lDebugLevel) printf ("Groesse Audio Track %d: %ld\n", i, lAudioKBPS/8*lAnzahlSekunden*1000);
                                  if (!lAudioTrackDeutsch && strcmp(lang_code, "de")==0)
                                  {
                                    lPlatzAudioDeutsch=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                  if (!lAudioTrackEnglisch && strcmp(lang_code, "en")==0)
                                  {
                                    lPlatzAudioEnglisch=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                  if (lSprachAuswahl == 4 && !lZusatzAudioTrack && strcmp(lang_code, szZusatzSprache)==0)
                                  {
                                    lZusatzPlatzAudio=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                }
                                if (strcmp (audio_format[audio_attr->audio_format], "dts") == 0)
                                {
                                  long lAudioKBPS=768; //1509;
                                  // dts hat in der Regel bessere Qualitaet als ac3, daher dts
                                  // bevorzugen.
                                  if (lAudioTrackDeutsch && strcmp(lang_code, "de")==0 && lAudioDefault == 2)
                                  {
                                    lAudioTrackDeutsch = 0; // wird mit folgenden Abfragen neu gesetzt
                                  }
                                  if (lAudioTrackEnglisch && strcmp(lang_code, "en")==0 && lAudioDefault == 2)
                                  {
                                    lAudioTrackEnglisch = 0; // wird mit folgenden Abfragen neu gesetzt
                                  }
                                  if (lSprachAuswahl == 4 && lZusatzAudioTrack && strcmp(lang_code, szZusatzSprache)==0 && lAudioDefault == 2)
                                  {
                                    lZusatzAudioTrack = 0; // wird mit folgenden Abfragen neu gesetzt
                                  }
                                  lPlatzAudio += (lAudioKBPS/8*lAnzahlSekunden*1000);
                                  if (lDebugLevel) printf ("Groesse Audio Track %d: %ld\n", i, lAudioKBPS/8*lAnzahlSekunden*1000);
                                  if (!lAudioTrackDeutsch && strcmp(lang_code, "de")==0)
                                  {
                                    lPlatzAudioDeutsch=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                  if (!lAudioTrackEnglisch && strcmp(lang_code, "en")==0)
                                  {
                                    lPlatzAudioEnglisch=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                  if (lSprachAuswahl == 4 && !lZusatzAudioTrack && strcmp(lang_code, szZusatzSprache)==0)
                                  {
                                    lZusatzPlatzAudio=lAudioKBPS/8*lAnzahlSekunden*1000;
                                  }
                                }
                                if (!lAudioTrackDeutsch && strcmp(lang_code, "de")==0)
                                {
                                  lAudioTrackDeutsch=i+1;
                                  strcpy (szAudioFormatDeutsch, audio_format[audio_attr->audio_format]);
                                  lAnzahlChannelDeutsch = audio_attr->channels+1;
                                }
                                if (!lAudioTrackEnglisch && strcmp(lang_code, "en")==0)
                                {
                                  lAudioTrackEnglisch=i+1;
                                  strcpy (szAudioFormatEnglisch, audio_format[audio_attr->audio_format]);
                                  lAnzahlChannelEnglisch = audio_attr->channels+1;
                                }
                                if (lSprachAuswahl == 4 && !lZusatzAudioTrack && strcmp(lang_code, szZusatzSprache)==0)
                                {
                                  lZusatzAudioTrack=i+1;
                                  strcpy (szZusatzAudioFormat, audio_format[audio_attr->audio_format]);
                                  lZusatzAnzahlChannel = audio_attr->channels+1;
                                }
                                lAnzahlAudioTracks = i+1;
                                strcpy (szAudioFormatAllgemein, audio_format[audio_attr->audio_format]);
                          }
                	}
		}
		}

		// CHAPTERS
		cell = 0;
		if (opt_c) {
		if (opt_p) {
		        unsigned long total_sectors = 0;
			ARRAY("chapter");
			for (i=0; i<pgc->nr_of_programs; i++)
			{
				int ms=0;
				int next = pgc->program_map[i+1];
				unsigned long sectors = 0;
				if (i == pgc->nr_of_programs - 1) next = pgc->nr_of_cells + 1;
				while (cell < next - 1)
				{
					ms = ms + dvdtime2msec(&pgc->cell_playback[cell].playback_time);
					sectors += pgc->cell_playback[cell].last_sector - pgc->cell_playback[cell].first_sector + 1;
					cell++;
				}
				total_sectors += sectors;
				HASH(0);
				DEF("ix", "%d", i+1);
				DEF("length", "%.3f", ms/1000.0);
				DEF("startcell", "%d", pgc->program_map[i]);
				DEF("sectors", "%lu", sectors);
				RETURN;
			}
			RETURN;
			DEF("sectors", "%lu", total_sectors);
		} else {
		        unsigned long total_sectors = 0;
                        long long lMilliSekunden = 0;
                        strcpy (szChapterString,"-c 0");
                        lTestKapitel = ((pgc->nr_of_programs+1) / 2)+1;
			for (i=0; i<pgc->nr_of_programs; i++)
	                {

       				int second=0, minute=0, hour=0, tmp;
	                        char hex[2];

	                        int next = pgc->program_map[i+1];
				unsigned long sectors = 0;
	                        if (i == pgc->nr_of_programs - 1) next = pgc->nr_of_cells + 1;
	                        while (cell < next - 1)
	                        {
                                        lMilliSekunden += millisekunden(&pgc->cell_playback[cell].playback_time);
	                                sprintf(hex, "%02x", pgc->cell_playback[cell].playback_time.second);
	                                tmp = second + atoi(hex);
	                                minute = minute + (tmp / 60);
	                                second = tmp % 60;
	                                sprintf(hex, "%02x", pgc->cell_playback[cell].playback_time.minute);
	                                tmp = minute + atoi(hex);
        	                        hour = hour + (tmp / 60);
	                                minute = tmp % 60;
					sectors += pgc->cell_playback[cell].last_sector - pgc->cell_playback[cell].first_sector + 1;
	                                cell++;
	                        }
				total_sectors += sectors;

                                // Kapitelanzahl des Testkapitels setzen
                                if ((i+1) == lTestKapitel)
                                  lSektorenTestkapitel = sectors;

                                if (lDebugLevel) printf("\tChapter: %02d, Length: %02d:%02d:%02d, Start Cell: %02d, Sectors: %7lu\n",
			           i+1, hour, minute, second, pgc->program_map[i], sectors);
                                // Das letzte Kapitel muss nicht mehr angegeben werden,
                                // da jeweils Startzeit
                                if (i < (pgc->nr_of_programs-1))
                                {
                                  char szDummy[128];
                                  sprintf(szDummy, ",%02lld:%02lld:%02lld.%03lld", lMilliSekunden/3600000, (lMilliSekunden/60000)%60, (lMilliSekunden/1000)%60, lMilliSekunden%1000);
                                  strcat (szChapterString, szDummy);
                                }
        	        }
			if (lDebugLevel) printf("\tTotal sectors: %lu\n", total_sectors);
                        lAnzahlSektoren = total_sectors; 
		}
		}
		// CELLS
		if (opt_d) {
		if (opt_p) {
			ARRAY("cell");
			for (i=0; i<pgc->nr_of_cells; i++)
			{
				HASH(0);
				DEF("ix", "%d", i+1);
				DEF("length", "%.3f", dvdtime2msec(&pgc->cell_playback[i].playback_time)/1000.0);
				RETURN;
			}
			RETURN;
		} else {
			for (i=0; i<pgc->nr_of_cells; i++)   
	                {
                        	if (lDebugLevel) printf("\tCell: %02d, Length: %02x:%02x:%02x\n", i+1, pgc->cell_playback[i].playback_time.hour,  
						pgc->cell_playback[i].playback_time.minute, pgc->cell_playback[i].playback_time.second);
	                }
		}
		}

		// SUBTITLES
		if (opt_s) {
		if (opt_p) {
			ARRAY("subp");
			for (i=0; i<vtsi_mat->nr_of_vts_subp_streams; i++)
			{
				subp_attr = &vtsi_mat->vts_subp_attr[i];
				sprintf(lang_code, "%c%c", subp_attr->lang_code>>8, subp_attr->lang_code & 0xff);
				if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
	
				HASH(0);
				DEF("ix", "%d", i+1);
				DEF("langcode", "'%s'", lang_code);
				DEF("language", "'%s'", lang_name(lang_code));
				DEF("content", "'%s'", subp_type[subp_attr->lang_extension]);
				RETURN;
			}
			RETURN;
		} else {
                        if (lUntertitel == -2) // Auswahl ueber Sprache
                        {
  			  for (i=0; i<vtsi_mat->nr_of_vts_subp_streams; i++)
	                  {
	                        subp_attr = &vtsi_mat->vts_subp_attr[i];
	                        sprintf(lang_code, "%c%c", subp_attr->lang_code>>8, subp_attr->lang_code & 0xff);
	                        if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
                                if (strcmp (szUntertitelSprache, lang_code) == 0)
                                {
                                  lUntertitel = i+1;
                                  break;
                                }
                          }
                        }
                        if (lUntertitel == -1) // Untertitel anzeigen
                        {
                          long lZaehler=0;
                          char szTrackNr[128];
                          char szTrack1[128];
                          if (lSprache==0)
                            printf ("\nListe der verfuegbaren Untertitel:\n\n");
                          else
                            printf ("\nList of available subpicture tracks:\n\n");
  			  for (i=0; i<vtsi_mat->nr_of_vts_subp_streams; i++)
	                  {
	                        subp_attr = &vtsi_mat->vts_subp_attr[i];
	                        sprintf(lang_code, "%c%c", subp_attr->lang_code>>8, subp_attr->lang_code & 0xff);
	                        if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
                                if (lSprache == 0)
                                {
  	                          printf("\tUntertitel: %02d, Sprache: %s - %s, ", i+1, lang_code, lang_name(lang_code));
  	                          printf("Inhalt: %s", subp_type[subp_attr->lang_extension]);
                                } else
                                {
	                          printf("\tSubtitle: %02d, Language: %s - %s, ", i+1, lang_code, lang_name(lang_code));
  	                          printf("Content: %s", subp_type[subp_attr->lang_extension]);
                                }
	                        printf("\n");  
                                lZaehler++;
                                if (lZaehler == 15) // Max 15. Zeilen, dann naechste Seite
                                {
                                  printf ("=> Enter\n");
                                  eatToNL(stdin);
                                  lZaehler = 0;
                                }
                          }
                          // Track-Nr eingeben
                          if (lSprache==0)
                            printf ("\nWelche Tracks? Bsp: Fuer Track 1 und 3 muss \"1,3\" eingegeben werden !\n");
                          else
                            printf ("\nWhich tracks? I. E.: For track 1 and 3 you have to enter \"1,3\" !\n");
                          scanf ("%s", szTrackNr);
                          eatToNL(stdin);
                          if (!strstr (szTrackNr, ","))
                          {
                            lUntertitel = atol (szTrackNr);
                            lUntertitel2 = 0;
                          }
                          strcpy (szTrack1, "");
                          for (i=0; i<strlen(szTrackNr); i++)
                          {
                            if (szTrackNr[i] != ',')
                              strncat (szTrack1, &szTrackNr[i], 1);
                            else
                            {
                              lUntertitel  = atol (szTrack1);
                              lUntertitel2 = atol (&szTrackNr[i+1]);
                              break;
                            }
                          }
                        }
			for (i=0; i<vtsi_mat->nr_of_vts_subp_streams; i++)
	                {
	                        subp_attr = &vtsi_mat->vts_subp_attr[i];
	                        sprintf(lang_code, "%c%c", subp_attr->lang_code>>8, subp_attr->lang_code & 0xff);
	                        if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
	                        if (lDebugLevel) printf("\tSubtitle: %02d, Language: %s - %s, ", i+1, lang_code, lang_name(lang_code));
	                        if (lDebugLevel) printf("Content: %s", subp_type[subp_attr->lang_extension]);
	                        if (lDebugLevel) printf("\n");  
                                // Untertitel fuer DVD-Author zusammensetzen
                                if (lUntertitel && (i == (lUntertitel-1)))
                                {
                                  sprintf (szUntertitelOptionen, "-s %s", lang_code);
                                }
	                }
                        if (lUntertitel2)
                        {
  			  for (i=0; i<vtsi_mat->nr_of_vts_subp_streams; i++)
	                  {
	                        subp_attr = &vtsi_mat->vts_subp_attr[i];
	                        sprintf(lang_code, "%c%c", subp_attr->lang_code>>8, subp_attr->lang_code & 0xff);
	                        if (!lang_code[0]) { lang_code[0] = 'x'; lang_code[1] = 'x'; }
	                        if (lDebugLevel) printf("\tSubtitle: %02d, Language: %s - %s, ", i+1, lang_code, lang_name(lang_code));
	                        if (lDebugLevel) printf("Content: %s", subp_type[subp_attr->lang_extension]);
	                        if (lDebugLevel) printf("\n");  
                                // Untertitel fuer DVD-Author zusammensetzen
                                if (lUntertitel2 && (i == (lUntertitel2-1)))
                                {
                                  sprintf (szUntertitelOptionen, "%s,%s", szUntertitelOptionen, lang_code);
                                }
                          }
	                }
                        if (lSprache==0)
                          printf ("\nUntertitel-Track-Nr: %ld/%ld/%s\n", 
                                  lUntertitel, lUntertitel2, szUntertitelOptionen);
                        else
                          printf ("\nSubpicture-Track-No: %ld/%ld/%s\n", 
                                  lUntertitel, lUntertitel2, szUntertitelOptionen);

		}
		}
	RETURN;	
	}
	if ( ! opt_p && (opt_a || opt_c || opt_p || opt_s || opt_n)) if (lDebugLevel) printf("\n");
	}
	}
	RETURN;
	if (! opt_t) {
		if (opt_p) {
			DEF("longest_track", "%d", max_track);
		} else {
			if (lDebugLevel) printf("Longest track: %d\n", max_track);
		}
	}

        for (i=1; i <= ifo_zero->vts_atrt->nr_of_vtss; i++) {
		ifoClose(ifo[i]);
	}
	ifoClose(ifo_zero);
	DVDClose(dvd);

        if (!lAudioTrackDeutsch && (lSprachAuswahl==1 || lSprachAuswahl==3))
        {
          if (lSprache == 0)
            printf ("Kein deutscher Audiotrack (verwende -a=2)!\n");
          else
            printf ("No german audiotrack (try -a=2)!\n");
          STOP;
	  return 0;
        }
        if (!lAudioTrackEnglisch && (lSprachAuswahl==2 || lSprachAuswahl==3))
        {
          if (lSprache == 0)
            printf ("Kein englischer Audiotrack (verwende -a=1)!\n");
          else
            printf ("No english audiotrack (try -a=1)!\n");
          STOP;
	  return 0;
        }
        if (!lZusatzAudioTrack && lSprachAuswahl==4)
        {
          if (lSprache == 0)
            printf ("Kein Audiotrack in gewaehlter Sprache '%s', bitte mit lsdvd ueberpruefen!\n", szZusatzSprache);
          else
            printf ("No audiotrack in selected language '%s', please check with lsdvd!\n", szZusatzSprache);
          STOP;
	  return 0;
        }

        if (dFaktor > 0 || lPackMethode == 5) 
        {
          lPlatzVideo = ((long long)lAnzahlSektoren * (long long)2048); //wegen Anzeige unten
        }

        // Testrip eines Kapitel mit tccat/tcextract, um den Faktor zu bestimmen (-f=-1)
        // Alternativ streamanalyze (-f=-2)
        if (dFaktor < 0)
        {
          lPlatzVideo = ((long long)2 * (long long)lAnzahlSektoren) / ((long long)1024);
          if (lPlatzVideo <= 4380) // KB je DVD 
          {
            dFaktor=1; // keine Requantisierung
            lPlatzVideo = ((long long)lAnzahlSektoren * (long long)2048); //wegen Anzeige unten
            if (lSprache == 0)
              printf ("Testrip unnoetig, Groesse DVD kleiner als 4380 MB, nehme Faktor 1.0!\n");
            else
              printf ("Testrip unnecessary, DVD < 4380 MB, Factor 1.0!\n");
          }
          else 
          {
            if (dFaktor == -1)
            {
              char szSprachFormat[12];
              char szAudioFormat1[12];
              char szAudioFormat2[12];
              long lAudioSpur;
              long long lTestVideo=0;
              long long lTestAudio=0;
              struct stat tmpStat;
              if (lSprache == 0)
                printf ("Faktorberechnung mit Transcode\n\n");
              else
                printf ("Calculation of requant factor with transcode\n\n");
              // Tests auf Programme
              check_program (tccat_name, lSprache);
              check_program (tcextract_name, lSprache);
              printf ("\nTestrip Kapitel %ld\n", lTestKapitel);
              if (lSprache == 0)
                printf ("Anzahl Sektoren gesamt: %ld / Sektoren Testkapitel: %ld\n",
                        lAnzahlSektoren, lSektorenTestkapitel);
              // Nun mit Transcode per Pipes das Kapitel rippen
              // Videospur
              system ("mkfifo /tmp/vid.fifo");
              sprintf (szBefehl, "%s -i /tmp/vid.fifo -t vob -x mpeg2 > /tmp/ofile.m2v &", 
                                 tcextract_name);
              printf ("%s\n", szBefehl);
              system (szBefehl);
              // Audiospur 1
              system ("mkfifo /tmp/aud1.fifo");
              switch (lSprachAuswahl)
              {
                case 1:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
                case 2:  lAudioSpur = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
                case 3:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
                case 4:  lAudioSpur = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
                case 5:  lAudioSpur = lAudioTrackInput1;   strcpy (szAudioFormat1, szFormatInput1); break;
              }
              lAudioSpur--; // tcextrcat beginnt mit Spur 0
              sprintf (szBefehl, "%s -i /tmp/aud1.fifo -t vob -x %s -a %ld > /tmp/ofile.ac3 &", 
                                 tcextract_name, szAudioFormat1, lAudioSpur);
              printf ("%s\n", szBefehl);
              system (szBefehl);
              if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
                  (lSprachAuswahl==5 && lAudioTrackInput2>0)
                 )
              {
                system ("mkfifo /tmp/aud2.fifo");
                if (lSprachAuswahl==3)
                {
                  lAudioSpur = lAudioTrackEnglisch; 
                  strcpy (szAudioFormat2, szAudioFormatEnglisch);
                } else
                {
                  lAudioSpur = lAudioTrackInput2;   
                  strcpy (szAudioFormat2, szFormatInput2);
                }
                lAudioSpur--; // tcextrcat beginnt mit Spur 0
                sprintf (szBefehl, "%s -i /tmp/aud2.fifo -t vob -x %s -a %ld > /tmp/ofile_2.ac3 &", 
                                   tcextract_name, szAudioFormat2, lAudioSpur);
                printf ("%s\n", szBefehl);
                system (szBefehl);
                sprintf (szBefehl, "%s -i %s -T %ld,%ld | tee /tmp/aud1.fifo /tmp/aud2.fifo /tmp/vid.fifo > /dev/null",
                                   tccat_name, dvd_device, opt_t, lTestKapitel);
              } else
              {
                sprintf (szBefehl, "%s -i %s -T %ld,%ld | tee /tmp/aud1.fifo /tmp/vid.fifo > /dev/null",
                                   tccat_name, dvd_device, opt_t, lTestKapitel);
              }
              printf ("%s\n", szBefehl);
              system (szBefehl);
              // Pipes wieder loeschen
              system ("rm /tmp/vid.fifo");
              system ("rm /tmp/aud1.fifo");
              if ((lSprachAuswahl == 3) ||
                  (lSprachAuswahl == 5 && lAudioTrackInput2>0)
                 )
              {
                system ("rm /tmp/aud2.fifo");
              }
              // Groessenberechnung
              // Einzelne Dateien berechnen
              if (stat ("/tmp/ofile.m2v", &tmpStat) == 0)
              {
                lTestVideo = tmpStat.st_size;
              }
              if (stat ("/tmp/ofile.ac3", &tmpStat) == 0)
              {
                lTestAudio += tmpStat.st_size;
              }
              if (stat ("/tmp/ofile_2.ac3", &tmpStat) == 0)
              {
                lTestAudio += tmpStat.st_size;
              } 
              if (lTestAudio > 0 && lTestVideo > 0)
              {
                // Umrechnen auf Gesamtfilm 
                lTestVideo = lTestVideo * (long long)lAnzahlSektoren / (long long)lSektorenTestkapitel;
                lTestAudio = lTestAudio * (long long)lAnzahlSektoren / (long long)lSektorenTestkapitel;
                printf ("Groesse Videotrack in Bytes:  %lld\n", lTestVideo);
                printf ("Groesse Audiotracks in Bytes: %lld\n", lTestAudio);
                dFaktor = (double)lTestVideo / (double)(lGroesseDVDBytes-lTestAudio);
                if (dFaktor < 1) dFaktor = 1;
                dFaktor = dFaktor + (dFaktor/(double)100*(double)3); // 3 % Reserve allgemein
                if (lUntertitel != 0) dFaktor = dFaktor + (dFaktor/(double)100); // 1 % Reserve bei Untertiteln
                if (lSprache == 0)
                  printf ("Ergebnis Testrip: Faktor: %f\n", dFaktor);
                else
                  printf ("Result of testrip: factor: %f\n", dFaktor);
              } else
              {
                // Testrip hat nicht funktioniert, also mit Faktor 0 neu setzen
                if (lSprache == 0)
                  printf ("\nTestrip fehlgeschlagen, Faktor wird berechnet!\n");
                else
                  printf ("\nTestrip failed, factor will be calculated!\n");
                dFaktor = 0;
              }
              lPlatzVideo = ((long long)lAnzahlSektoren * (long long)2048); //wegen Anzeige unten
              // Und nun auch noch alle TMP-Dateien loeschen
              system ("rm /tmp/ofile.m2v");
              system ("rm /tmp/ofile.ac3");
              if ((lSprachAuswahl == 3) ||
                  (lSprachAuswahl == 5 && lAudioTrackInput2>0)
                 )
              {
                system ("rm /tmp/ofile_2.ac3");
              }
            } else
            {
              long lRC;
              char szTempl[32] = "/tmp/factor.XXXXXX";
              char szAudioFormat1[12];
              char szAudioFormat2[12];
              long lAudioSpur;
              if (lSprache == 0)
                printf ("Faktorberechnung mit streamanalyze\n\n");
              else
                printf ("Calculation of requant factor with streamanalyze\n\n");
              // Tests auf Programme
              check_program (streamanalyze_name, lSprache);
              // zu rippende Tracks festlegen, 
              // 0xe0=1. Videospur
              sprintf (szRipTracks, "-s 0xe0");
              // >= 0x80 Audiospur ac3
              // >= 0x88 dts
              // >= 0xA0 LPCM
              // >= 0xC0 MPEG1/2
              switch (lSprachAuswahl)
              {
                case 1:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
                case 2:  lAudioSpur = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
                case 3:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
                case 4:  lAudioSpur = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
                case 5:  lAudioSpur = lAudioTrackInput1;   strcpy (szAudioFormat1, szFormatInput1); break;
              }
              lAudioSpur--; 
              if (strstr (szAudioFormat1, "ac3")) 
              {
                lAudioSpur += 0x80;
              }
              if (strstr (szAudioFormat1, "dts")) 
              {
                lAudioSpur += 0x88;
              }
              if (strstr (szAudioFormat1, "lpcm")) 
              {
                lAudioSpur += 0xa0;
              }
              if (strstr (szAudioFormat1, "mpeg")) 
              {
                lAudioSpur += 0xc0;
              }
              sprintf (szRipTracks, "%s,0x%x", szRipTracks, lAudioSpur);
              if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
                  (lSprachAuswahl==5 && lAudioTrackInput2>0)
                 )
              {
                if (lSprachAuswahl==3)
                {
                  lAudioSpur = lAudioTrackEnglisch; 
                  strcpy (szAudioFormat2, szAudioFormatEnglisch);
                } else
                {
                  lAudioSpur = lAudioTrackInput2;   
                  strcpy (szAudioFormat2, szFormatInput2);
                }
                lAudioSpur--; // tcextrcat beginnt mit Spur 0
                if (strstr (szAudioFormat2, "ac3")) 
                {
                  lAudioSpur += 0x80;
                }
                if (strstr (szAudioFormat2, "dts")) 
                {
                  lAudioSpur += 0x88;
                }
                if (strstr (szAudioFormat2, "lpcm")) 
                {
                  lAudioSpur += 0xa0;
                }
                if (strstr (szAudioFormat2, "mpeg")) 
                {
                  lAudioSpur += 0xc0;
                }
                sprintf (szRipTracks, "%s,0x%x", szRipTracks, lAudioSpur);
              }
              // Mit Untertiteltrack (0=ohne)
              if (lUntertitel && strlen(szRipTracks))
              {
                long lUntertitelSpur=lUntertitel-1+0x20;
                sprintf (szRipTracks, "%s,0x%x", szRipTracks, lUntertitelSpur);
              }
              if (lUntertitel2 && strlen(szRipTracks))
              {
                long lUntertitelSpur=lUntertitel2-1+0x20;
                sprintf (szRipTracks, "%s,0x%x", szRipTracks, lUntertitelSpur);
              }
              mkstemp(szTempl);
              sprintf (szBefehl, "%s -i %s -t %d %s > %s 2>&1",
                                 streamanalyze_name, dvd_device, opt_t, szRipTracks, szTempl);
              printf ("%s\n", szBefehl);
              lRC = system (szBefehl);
              if (lRC == 0) // Ergebnis aus Datei auslesen, Faktor ist letzter String in Datei
              {
                FILE * fp;
                char szFaktor[1024];
                char szZeile[1024];
                strcpy (szZeile, "0");
                fp = fopen (szTempl, "r");
                while (fscanf(fp, "%s\n",szZeile) != EOF)
                {
                  strcpy (szFaktor, szZeile);
                }
                unlink(szTempl);
                if (szFaktor[0] < '0' || szFaktor[0] > '9')
                  dFaktor = 1; // Requant nicht noetig
                else
                  dFaktor = atof (szFaktor);
                // Bei Streamtool anders als streamdvd Sicherheitsreserve
                if (lPackMethode != 1 && dFaktor > 1)
                {
                  dFaktor += ((dFaktor / (double)100)*(double)2);
                  if (lUntertitel)
                    dFaktor += ((dFaktor / (double)100));
                }
                if (lSprache == 0)
                  printf ("Ergebnis Testrip: Faktor: %f\n", dFaktor);
                else
                  printf ("Result of testrip: factor: %f\n", dFaktor);
              } else
              {
                // Testrip hat nicht funktioniert, also mit Faktor 0 neu setzen
                if (lSprache == 0)
                  printf ("\nTestrip fehlgeschlagen, Faktor wird berechnet!\n");
                else
                  printf ("\nTestrip failed, factor will be calculated!\n");
                dFaktor = 0;
              }
              lPlatzVideo = ((long long)lAnzahlSektoren * (long long)2048); //wegen Anzeige unten
            }
          }  
        }

        if (lPackMethode != 5 && dFaktor == 0)
        {
          // Faktor Berechnung Stefan Becker          
          // Platz fuer Video in Bytes
          lPlatzVideo = ((long long)lAnzahlSektoren * (long long)2048);
          if (lPlatzVideo <= lGroesseDVDBytes)
            dFaktor=1; // keine Requantisierung
          else
          {
            switch (lSprachAuswahl)
            { 
              case 1: dFaktor = (double)(lPlatzVideo-lPlatzAudio) / (double)(lGroesseDVDBytes - lPlatzAudioDeutsch); break;
              case 2: dFaktor = (double)(lPlatzVideo-lPlatzAudio) / (double)(lGroesseDVDBytes - lPlatzAudioEnglisch); break;
              case 3: dFaktor = (double)(lPlatzVideo-lPlatzAudio) / (double)(lGroesseDVDBytes - lPlatzAudioDeutsch - lPlatzAudioEnglisch); break;
              case 4: dFaktor = (double)(lPlatzVideo-lPlatzAudio) / (double)(lGroesseDVDBytes - lZusatzPlatzAudio); break;
              case 5: dFaktor = (double)(lPlatzVideo-lPlatzAudio) / (double)(lGroesseDVDBytes - lLaengeInput1 - lLaengeInput2); break;
            }
            // 3 % aufschlagen zur Sicherheit
            dFaktor = dFaktor + (dFaktor/(double)100*(double)3);
            // Bei Untertiteln ein zusaetzliches Prozent Sicherheit
            if (lUntertitel)
            {
              dFaktor = dFaktor + (dFaktor/(double)100);
            }
            // Und ein Prozent Sicherheit bei 2 Audiospuren
            if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
                (lSprachAuswahl==5 && lAudioTrackInput2>0)
               )
            {
              dFaktor = dFaktor + (dFaktor/(double)100);
            }
          }  
          if (lSprache == 0)
            printf ("\nFaktor wird mit Abzug Audio Tracks berechnet !\n");
          else
            printf ("\nFactor will be calculated with substraction of audio tracks!\n");
        } 

        // Faktor unter 1 macht keinen Sinn
        if (dFaktor < 1)
        {
          printf ("Faktor %f wird auf 1 gesetzt!\n", dFaktor);
          dFaktor = 1;
        }

        if (lSprache == 0)
        {
          printf ("\n");
          printf ("Laengster Titel:        %d\n", max_track);
          printf ("\n");
          printf ("Infos zu Titel:         %d\n", opt_t);
          printf ("\n");
          printf ("Anzahl Sektoren:        %ld (%lld Bytes)\n",  lAnzahlSektoren, lPlatzVideo);
          printf ("Spieldauer in Sekunden: %ld\n",  lAnzahlSekunden);
          printf ("Anzahl Kapitel:         %ld\n",  lAnzahlKapitel);
          printf ("Anzahl Audio Streams:   %ld\n",  lAnzahlAudioStreams);
          if (lSprachAuswahl == 4)
          {
            printf ("Audio Track '%s':       %ld (%lld Bytes)\n", szZusatzSprache, lZusatzAudioTrack, lZusatzPlatzAudio);
          } else
          {
            if (lSprachAuswahl == 5)
            {
              printf ("Audio Track 1 (%s):     %ld (%lld Bytes)\n", szSpracheInput1, lAudioTrackInput1, lLaengeInput1);
              printf ("Audio Track 2 (%s):     %ld (%lld Bytes)\n", szSpracheInput2, lAudioTrackInput2, lLaengeInput2);
            } else
            {
              printf ("Audio Track deutsch:    %ld (%lld Bytes)\n", lAudioTrackDeutsch, lPlatzAudioDeutsch);
              printf ("Audio Track Englisch:   %ld (%lld Bytes)\n", lAudioTrackEnglisch, lPlatzAudioEnglisch);
            }
          }
          printf ("Groesse AudioStreams:   %lld\n", lPlatzAudio);
          printf ("Groesse Video Stream:   %lld\n", lPlatzVideo-lPlatzAudio);
          printf ("Requantsierungsfaktor:  %f\n\n\n",   dFaktor);
        } else
        {
          printf ("\n");
          printf ("Longest title:          %d\n", max_track);
          printf ("\n");
          printf ("Infos for title:         %d\n", opt_t);
          printf ("\n");
          printf ("No of sectors:          %ld (%lld bytes)\n",  lAnzahlSektoren, lPlatzVideo);
          printf ("Length of film in seconds: %ld\n",  lAnzahlSekunden);
          printf ("No of chapters:         %ld\n",  lAnzahlKapitel);
          printf ("No of audio streams:    %ld\n",  lAnzahlAudioStreams);
          if (lSprachAuswahl == 4)
          {
            printf ("Audio track '%s':       %ld (%lld bytes)\n", szZusatzSprache, lZusatzAudioTrack, lZusatzPlatzAudio);
          } else
          {
            if (lSprachAuswahl == 5)
            {
              printf ("Audio track 1 (%s):     %ld (%lld bytes)\n", szSpracheInput1, lAudioTrackInput1, lLaengeInput1);
              printf ("Audio Track 2 (%s):     %ld (%lld bytes)\n", szSpracheInput2, lAudioTrackInput2, lLaengeInput2);
            } else
            {
              printf ("Audio Track german:     %ld (%lld bytes)\n", lAudioTrackDeutsch, lPlatzAudioDeutsch);
              printf ("Audio Track english:    %ld (%lld bytes)\n", lAudioTrackEnglisch, lPlatzAudioEnglisch);
            }
          }
          printf ("Size of audio streams:   %lld\n", lPlatzAudio);
          printf ("Size of video:          %lld\n", lPlatzVideo);
          printf ("Requant-Factor:         %f\n\n\n",   dFaktor);
        }

        // Kapitelunterteilung uebernehmen ?
        if (!lMitKapiteln)
        {
          strcpy (szChapterString, ""); // ohne Kapitel
        }

        // DVD rippen mit streamdvd
        if (lPackMethode == 1)
        {
          char szAudioFormat1[128], szAudioFormat2[128];
          long lAudioSpur;
          // Tests auf Programme
          check_program (dvdauthor_name, lSprache);
          check_program (streamdvd_name, lSprache);
          // zu rippende Tracks festlegen, 
          // 0xe0=1. Videospur
          sprintf (szRipTracks, "-s 0xe0");
          // >= 0x80 Audiospur ac3
          // >= 0x88 dts
          // >= 0xA0 LPCM
          // >= 0xC0 MPEG1/2
          switch (lSprachAuswahl)
          {
            case 1:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
            case 2:  lAudioSpur = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
            case 3:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
            case 4:  lAudioSpur = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
            case 5:  lAudioSpur = lAudioTrackInput1;   strcpy (szAudioFormat1, szFormatInput1); break;
          }
          lAudioSpur--; 
          if (strstr (szAudioFormat1, "ac3")) 
          {
            lAudioSpur += 0x80;
          }
          if (strstr (szAudioFormat1, "dts")) 
          {
            lAudioSpur += 0x88;
          }
          if (strstr (szAudioFormat1, "lpcm")) 
          {
            lAudioSpur += 0xa0;
          }
          if (strstr (szAudioFormat1, "mpeg")) 
          {
            lAudioSpur += 0xc0;
          }
          sprintf (szRipTracks, "%s,0x%x", szRipTracks, lAudioSpur);
          if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
              (lSprachAuswahl==5 && lAudioTrackInput2>0)
             )
          {
            if (lSprachAuswahl==3)
            {
              lAudioSpur = lAudioTrackEnglisch; 
              strcpy (szAudioFormat2, szAudioFormatEnglisch);
            } else
            {
              lAudioSpur = lAudioTrackInput2;   
              strcpy (szAudioFormat2, szFormatInput2);
            }
            lAudioSpur--; // tcextrcat beginnt mit Spur 0
            if (strstr (szAudioFormat2, "ac3")) 
            {
              lAudioSpur += 0x80;
            }
            if (strstr (szAudioFormat2, "dts")) 
            {
              lAudioSpur += 0x88;
            }
            if (strstr (szAudioFormat2, "lpcm")) 
            {
              lAudioSpur += 0xa0;
            }
            if (strstr (szAudioFormat2, "mpeg")) 
            {
              lAudioSpur += 0xc0;
            }
            sprintf (szRipTracks, "%s,0x%x", szRipTracks, lAudioSpur);
          }
          // Mit Untertiteltrack (0=ohne)
          if (lUntertitel && strlen(szRipTracks))
          {
            long lUntertitelSpur=lUntertitel-1+0x20;
            sprintf (szRipTracks, "%s,0x%x", szRipTracks, lUntertitelSpur);
          }
          if (lUntertitel2 && strlen(szRipTracks))
          {
            long lUntertitelSpur=lUntertitel2-1+0x20;
            sprintf (szRipTracks, "%s,0x%x", szRipTracks, lUntertitelSpur);
          }
          // Befehl dvdauthor fuer Bildung des DVD-Titels zusammensetzen
          switch (lSprachAuswahl)
          {
            case 1:  sprintf (szBefehl, "%s -t -a %s+de ", dvdauthor_name, szAudioFormatDeutsch); break;
            case 2:  sprintf (szBefehl, "%s -t -a %s+en ", dvdauthor_name, szAudioFormatEnglisch); break;
            case 3:  sprintf (szBefehl, "%s -t -a %s+de,%s+en ", dvdauthor_name, szAudioFormatDeutsch, szAudioFormatEnglisch); break;
            case 4:  sprintf (szBefehl, "%s -t -a %s+%s ", dvdauthor_name, szZusatzAudioFormat, szZusatzSprache); break;
            case 5:  if (!strstr (szAudioFormat1, "mp3") && !strstr (szAudioFormat2, "mp3") &&
                         !strstr (szAudioFormat1, "lpcm") && !strstr (szAudioFormat2, "lpcm")
                        ) 
                     { 
                       sprintf (szBefehl, "%s -t -a %s+%s", dvdauthor_name, szFormatInput1, szSpracheInput1);
                       if (lAudioTrackInput2 > 0)
                       {
                         strcat (szBefehl, ",");
                         strcat (szBefehl, szFormatInput2);
                         strcat (szBefehl, "+");
                         strcat (szBefehl, szSpracheInput2);
                       }
                     } else
                     {
                       // Bei mpeg1 und lpcm Audiostream dvdauthor ohne Format starten
                       sprintf (szBefehl, "%s -t -a %s", dvdauthor_name, szSpracheInput1);
                       if (lAudioTrackInput2 > 0)
                       {
                         strcat (szBefehl, ",");
                         strcat (szBefehl, szSpracheInput2);
                       }
                     }
                     strcat (szBefehl, " ");
                     break;
            default: sprintf (szBefehl, "%s -t -a %s+de ", dvdauthor_name, szAudioFormatDeutsch); break;
          }
          if (!strlen (szOutputFile)) // normale Ausgabe mit dvdauthor
          {
            sprintf (szBefehl2, "%s %s %s %s -o %s -f '%s -i %s -t %d -f %f %s |'",
                                szBefehl, szPaletteOptions, szUntertitelOptionen, szChapterString, szFilmVerzeichnis, 
                                streamdvd_name, dvd_device, opt_t, dFaktor, szRipTracks);
            printf ("%s\n", szBefehl2);
            system (szBefehl2);
          } else
          {                           // Ergebnis ist eine Datei
            sprintf (szBefehl2, "%s -i %s -t %d -f %f %s > %s",
                                streamdvd_name, dvd_device, opt_t, dFaktor, szRipTracks, szOutputFile);
            printf ("%s\n", szBefehl2);
            system (szBefehl2);
            if (lSprache == 0)
              printf ("\nFertig!\n");
            else
              printf ("\nReady!\n");
            return 0;
          }
        }

        // DVD rippen mit der Methode transcode parallel
        // Ersatz fuer vamps-Methode ab Version 0.80
        if (lPackMethode == 2)
        {
          long lAudioSpur1, lAudioSpur2;
          char szAudioFormat1[128];
          char szAudioFormat2[128];
          char szBufferBefehl[128];
          char szAudioFormatTranscode[12];
          char szPipeUntertitel[128];
          char szPipeMPEG[128];
          // Tests auf Programme
          check_program (dvdauthor_name, lSprache);
          check_program (tccat_name, lSprache);
          check_program (tcextract_name, lSprache);
          if (lUntertitel)
          {
            check_program (spumux_name, lSprache);
            check_program (spuunmux_name, lSprache);
          }
          if (dFaktor > 1) check_program (tcrequant_name, lSprache);
          check_program (mplex_name, lSprache);
          check_program (buffer_name, lSprache);
          // 1. Audiotrack: Format und TrackNr bestimmen
          switch (lSprachAuswahl)
          {
            case 1:  lAudioSpur1 = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
            case 2:  lAudioSpur1 = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
            case 3:  lAudioSpur1 = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
            case 4:  lAudioSpur1 = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
            case 5:  lAudioSpur1 = lAudioTrackInput1;   strcpy (szAudioFormat1, szFormatInput1); break;
          }
          lAudioSpur1--; // tcextrcat beginnt mit Spur 0
          // 2. Audiotrack: Format und TrackNr bestimmen
          if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
              (lSprachAuswahl==5 && lAudioTrackInput2>0)
             )
          {
            if (lSprachAuswahl==3)
            {
              lAudioSpur2 = lAudioTrackEnglisch; 
              strcpy (szAudioFormat2, szAudioFormatEnglisch);
            } else
            {
              lAudioSpur2 = lAudioTrackInput2;   
              strcpy (szAudioFormat2, szFormatInput2);
            }
            lAudioSpur2--; // tcextrcat beginnt mit Spur 0
          }
          // Befehl fuer Buffer-Programm zusammensetzen
          sprintf (szBufferBefehl, "%s -s 64k -m 16m -i", buffer_name); // nehme buffer
          // Pipes anlegen
          system ("mkfifo /tmp/foo.s1");
          system ("mkfifo /tmp/foo.s2");
          sprintf (szBefehl, "mkfifo /tmp/foo.%s", szAudioFormat1);
          system (szBefehl);
          system ("mkfifo /tmp/foo.m2v");
          if (lUntertitel) // Pipe fuer Untertitel
          {
            system ("mkfifo /tmp/foo.sub");
            sprintf (szBefehl, "%s /tmp/foo.sub | %s -o /tmp/dvd -s %ld %s /dev/stdin &",
                               szBufferBefehl, spuunmux_name, lUntertitel-1, szPaletteOptions); 
            printf ("%s\n", szBefehl);
            system (szBefehl);
            system ("sleep 1");
            strcpy (szPipeUntertitel, "/tmp/foo.sub");
            if (lUntertitel2)
            {
              system ("mkfifo /tmp/foo.sub2");
              sprintf (szBefehl, "%s /tmp/foo.sub2 | %s -o /tmp/dvd2 -s %ld %s /dev/stdin &",
                                 szBufferBefehl, spuunmux_name, lUntertitel2-1, szPaletteOptions); 
              printf ("%s\n", szBefehl);
              system (szBefehl);
              system ("sleep 1");
              strcpy (szPipeUntertitel, "/tmp/foo.sub /tmp/foo.sub2");
            }
            sprintf (szPipeMPEG, "%s/film-neu.vob", szTmpDir);
          } else
          {
            strcpy (szPipeUntertitel, "");
            sprintf (szPipeMPEG, "/tmp/foo.mpeg");
            system ("mkfifo /tmp/foo.mpeg");
          }
          if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
              (lSprachAuswahl==5 && lAudioTrackInput2>0)
             )
          {
            system ("mkfifo /tmp/foo.s3");
            sprintf (szBefehl, "mkfifo /tmp/foo_a2.%s", szAudioFormat2);
            system (szBefehl);
            sprintf (szBefehl, "%s -f 8 -o %s /tmp/foo.m2v /tmp/foo.%s /tmp/foo_a2.%s -S 0 &",
                               mplex_name, szPipeMPEG, szAudioFormat1, szAudioFormat2);
          } else
          {
            sprintf (szBefehl, "%s -f 8 -o %s /tmp/foo.m2v /tmp/foo.%s -S 0 &",
                               mplex_name, szPipeMPEG, szAudioFormat1);
          }
          printf ("%s\n", szBefehl);
          system (szBefehl);
          system ("sleep 1");
          // Videostream (tcrequant nur bei Faktor > 1 noetig)
          if (dFaktor > 1)
            sprintf (szBefehl, "%s /tmp/foo.s1 | %s -t vob -x mpeg2 | %s -f %f > /tmp/foo.m2v &",
                               szBufferBefehl, tcextract_name, tcrequant_name, dFaktor);
          else
            sprintf (szBefehl, "%s /tmp/foo.s1 | %s -t vob -x mpeg2 > /tmp/foo.m2v &",
                               szBufferBefehl, tcextract_name);
          printf ("%s\n", szBefehl);
          system (szBefehl);
          system ("sleep 1");
          // lpcm wird von Transcode als pcm gerippt
          strcpy (szAudioFormatTranscode, szAudioFormat1);
          if (strstr (szAudioFormat1, "lpcm"))
            strcpy (szAudioFormatTranscode, "pcm");
          // mpeg 1 Audio ist bei Transcode mp3
          if (strstr (szAudioFormat1, "mpeg"))
          {
            strcpy (szAudioFormatTranscode, "mp3");
            strcpy (szAudioFormat1, "mp3");
          }
          if (!strstr (szAudioFormatTranscode, "dts"))
          {
            sprintf (szBefehl, "%s /tmp/foo.s2 | %s -t vob -x %s -a %ld > /tmp/foo.%s &",
                               szBufferBefehl, tcextract_name, szAudioFormatTranscode, lAudioSpur1, szAudioFormat1);
          } else
          {
            long lTrackNr=0x88+lAudioSpur1;
            sprintf (szBefehl, "%s /tmp/foo.s2 | %s /dev/stdin -dumpaudio -aid %ld -dumpfile /tmp/foo.%s &",
                               szBufferBefehl, mplayer_name, lTrackNr, szAudioFormat1);
          }
          printf ("%s\n", szBefehl);
          system (szBefehl);
          system ("sleep 1");
          // 2. Audiotrack
          if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
              (lSprachAuswahl==5 && lAudioTrackInput2>0)
             )
          {
            // lpcm wird von Transcode als pcm gerippt
            strcpy (szAudioFormatTranscode, szAudioFormat2);
            if (strstr (szAudioFormat1, "lpcm"))
              strcpy (szAudioFormatTranscode, "pcm");
            // mpeg 1 Audio ist bei Transcode mp3
            if (strstr (szAudioFormat2, "mpeg"))
            {
              strcpy (szAudioFormatTranscode, "mp3");
              strcpy (szAudioFormat2, "mp3");
            }
            if (!strstr (szAudioFormatTranscode, "dts"))
            {
              sprintf (szBefehl, "%s /tmp/foo.s3 | %s -t vob -x %s -a %ld > /tmp/foo_a2.%s &",
                                 szBufferBefehl, tcextract_name, szAudioFormatTranscode, lAudioSpur2, szAudioFormat2);
            } else
            {
              long lTrackNr=0x88+lAudioSpur2;
              sprintf (szBefehl, "%s /tmp/foo.s3 | %s /dev/stdin -dumpaudio -aid %ld -dumpfile /tmp/foo_a2.%s &",
                                 szBufferBefehl, mplayer_name, lTrackNr, szAudioFormat2);
            }
            printf ("%s\n", szBefehl);
            system (szBefehl);
            system ("sleep 1");
            // DVD auslesen
            sprintf (szBefehl, "%s -i %s -T %ld,-1 | tee /tmp/foo.s1 /tmp/foo.s2 /tmp/foo.s3 %s >/dev/null",
                               tccat_name, dvd_device, opt_t, szPipeUntertitel);
          } else
          {
            // DVD auslesen
            sprintf (szBefehl, "%s -i %s -T %ld,-1 | tee /tmp/foo.s1 /tmp/foo.s2 %s >/dev/null",
                               tccat_name, dvd_device, opt_t, szPipeUntertitel);
          }
          // ohne Untertitel tccat parallel und alles in dvdauthor eingebettet,
          // mit Untertitel erfolgt Zwischenschritt
          if (lUntertitel == 0)
          {
            strcat (szBefehl, " &");
          }
          printf ("%s\n", szBefehl);
          system (szBefehl);
          system ("sleep 1");
          // Untertitel ins VOB muxen
          if (lUntertitel)
          {
            // Etwas warten, bis obige Programme fertig sind
            system ("sleep 20");
            // spumux zum multiplexen der Untertitel
            if (lUntertitel2==0)
              sprintf (szPipeMPEG, "-f '%s -m dvd -s 0 /tmp/dvd.xml < %s/film-neu.vob > /dev/stdout |'", 
                                   spumux_name, szTmpDir);
            else
              sprintf (szPipeMPEG, "-f '%s -m dvd -s 0 /tmp/dvd.xml < %s/film-neu.vob > /dev/stdout | "\
                                   "%s -m dvd -s 1 /tmp/dvd2.xml < /dev/stdin > /dev/stdout |'",
                                   spumux_name, szTmpDir, spumux_name);
          }
          // Befehl dvdauthor fuer Bildung des DVD-Titels zusammensetzen
          switch (lSprachAuswahl)
          {
            case 1:  sprintf (szBefehl, "%s -t -a %s+de ", dvdauthor_name, szAudioFormatDeutsch); break;
            case 2:  sprintf (szBefehl, "%s -t -a %s+en ", dvdauthor_name, szAudioFormatEnglisch); break;
            case 3:  sprintf (szBefehl, "%s -t -a %s+de,%s+en ", dvdauthor_name, szAudioFormatDeutsch, szAudioFormatEnglisch); break;
            case 4:  sprintf (szBefehl, "%s -t -a %s+%s ", dvdauthor_name, szZusatzAudioFormat, szZusatzSprache); break;
            case 5:  if (!strstr (szAudioFormat1, "mp3") && !strstr (szAudioFormat2, "mp3") &&
                         !strstr (szAudioFormat1, "lpcm") && !strstr (szAudioFormat2, "lpcm")
                        ) 
                     { 
                       sprintf (szBefehl, "%s -t -a %s+%s", dvdauthor_name, szFormatInput1, szSpracheInput1);
                       if (lAudioTrackInput2 > 0)
                       {
                         strcat (szBefehl, ",");
                         strcat (szBefehl, szFormatInput2);
                         strcat (szBefehl, "+");
                         strcat (szBefehl, szSpracheInput2);
                       } 
                       strcat (szBefehl, " ");
                     } else
                     {
                       // Bei mpeg1 und lpcm Audiostream dvdauthor ohne Format starten
                       sprintf (szBefehl, "%s -t -a %s", dvdauthor_name, szSpracheInput1);
                       if (lAudioTrackInput2 > 0)
                       {
                         strcat (szBefehl, ",");
                         strcat (szBefehl, szSpracheInput2);
                       }
                       strcat (szBefehl, " ");
                     }
                     break;
            default: sprintf (szBefehl, "%s -t -a %s+de ", dvdauthor_name, szAudioFormatDeutsch); break;
          }
          sprintf (szBefehl, "%s %s %s %s -o %s %s",
                   szBefehl, szChapterString, szPaletteOptions, szUntertitelOptionen, szFilmVerzeichnis, szPipeMPEG);
          printf ("%s\n", szBefehl);
          system (szBefehl);
          // Alle Pipes wieder loeschen
          system ("rm /tmp/foo.s1");
          system ("rm /tmp/foo.s2");
          sprintf (szBefehl, "rm /tmp/foo.%s", szAudioFormat1);
          system (szBefehl);
          system ("rm /tmp/foo.m2v");
          if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
              (lSprachAuswahl==5 && lAudioTrackInput2>0)
             )
          {
            system ("rm /tmp/foo.s3");
            sprintf (szBefehl, "rm /tmp/foo_a2.%s", szAudioFormat2);
            system (szBefehl);
          }
          if (lUntertitel) // Pipe fuer Untertitel
          {
            system ("rm /tmp/foo.sub");
            if (lUntertitel2)
            {
              system ("rm /tmp/foo.sub2");
            }
            // Ausserdem das XML-Script und die pngs loeschen
            system ("rm /tmp/dvd*.xml");
            system ("rm /tmp/dvd*.png");
            // Dummy-Datei zuletzt loeschen
            sprintf (szBefehl, "rm %s/film-neu.vob", szTmpDir);
            printf ("%s\n", szBefehl);
            system (szBefehl);
          } else
          {
            sprintf (szBefehl, "rm %s", szPipeMPEG);
            system (szBefehl);
          }
        }

        // Rippen per mplayer oder transcode (ab mplex sind beide Bloecke gleich)
        if (lPackMethode == 3 || lPackMethode == 4)
        {
          char szAudioFormat1[128];
          char szAudioFormat2[128];
          char szMplexAusgabe[128];
          char szVOBQuelle[1028];
          long lRC;
          // Tests auf Programme
          check_program (dvdauthor_name, lSprache);
          if (lPackMethode == 3)
            check_program (mplayer_name, lSprache);
          else
            check_program (tccat_name, lSprache);
          check_program (tcextract_name, lSprache);
          if (dFaktor > 1) check_program (tcrequant_name, lSprache);
          if (lMultiplexer==1)
            check_program (tcmplex_name, lSprache);
          else
            check_program (mplex_name, lSprache);
          if (lUntertitel > 0)
          {
            check_program (spuunmux_name, lSprache);
            check_program (spumux_name, lSprache);
          }
          // Tmp-Dir: muss immer ein "/" angehaengt haben
          if (szTmpDir[strlen(szTmpDir)-1] != '/')
            strcat (szTmpDir, "/");
          if (lPackMethode == 3)
          {
            long lAudioSpur;
            // Videospur
            // Bei Faktor = 1 ohne tcrequant, Zeit ist unnoetig
            if (dFaktor > 1)
              sprintf (szBefehl, "%s -dvd-device %s dvd://%ld -dumpstream -dumpfile /dev/stdout | %s -t vob -a 0 -x mpeg2 | %s -f %f > %sofile.m2v",
                                 mplayer_name, dvd_device, (long)opt_t, tcextract_name, tcrequant_name, dFaktor, szTmpDir);
            else
              sprintf (szBefehl, "%s -dvd-device %s dvd://%ld -dumpstream -dumpfile /dev/stdout | %s -t vob -a 0 -x mpeg2 > %sofile.m2v",
                                 mplayer_name, dvd_device, (long)opt_t, tcextract_name, szTmpDir);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            // Audiospur
            switch (lSprachAuswahl)
            {
              case 1:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
              case 2:  lAudioSpur = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
              case 3:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
              case 4:  lAudioSpur = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
              case 5:  lAudioSpur = lAudioTrackInput1;   
                       if (!strstr (szFormatInput1, "mpeg"))
                         strcpy (szAudioFormat1, szFormatInput1); 
                       else
                         strcpy (szAudioFormat1, "mp3"); 
                       break;
            }
            lAudioSpur--;
            // Umrechnen auf Track-ID, da über Parameter -aid erforderlich
            if (strstr (szAudioFormat1, "ac3")) 
            {
              lAudioSpur += 0x80;
            }
            if (strstr (szAudioFormat1, "dts")) 
            {
              lAudioSpur += 0x88;
            }
            if (strstr (szAudioFormat1, "lpcm")) 
            {
              lAudioSpur += 0xa0;
            }
            if (strstr (szAudioFormat1, "mp")) 
            {
              lAudioSpur += 0xc0;
            }
            sprintf (szBefehl, "%s -dvd-device %s dvd://%ld -aid %ld -dumpaudio -dumpfile %sofile.%s",
                               mplayer_name, dvd_device, (long)opt_t, lAudioSpur, szTmpDir, szAudioFormat1);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
                (lSprachAuswahl==5 && lAudioTrackInput2>0)
               )
            {
              if (lSprachAuswahl==3)
              {
                lAudioSpur = lAudioTrackEnglisch; 
                strcpy (szAudioFormat2, szAudioFormatEnglisch);
              } else
              {
                lAudioSpur = lAudioTrackInput2;  
                if (!strstr (szFormatInput2, "mpeg")) 
                  strcpy (szAudioFormat2, szFormatInput2);
                else
                  strcpy (szAudioFormat2, "mp3");
              }
              lAudioSpur--; // tcextrcat beginnt mit Spur 0
              // Umrechnen auf Track-ID, da über Parameter -aid erforderlich
              if (strstr (szAudioFormat2, "ac3")) 
              {
                lAudioSpur += 0x80;
              }
              if (strstr (szAudioFormat2, "dts")) 
              {
                lAudioSpur += 0x88;
              }
              if (strstr (szAudioFormat2, "lpcm")) 
              {
                lAudioSpur += 0xa0;
              }
              if (strstr (szAudioFormat2, "mp")) 
              {
                lAudioSpur += 0xc0;
              }
              sprintf (szBefehl, "%s -dvd-device %s dvd://%ld -aid %ld -dumpaudio -dumpfile %sofile_2.%s",
                                 mplayer_name, dvd_device, (long)opt_t, lAudioSpur, szTmpDir, szAudioFormat2);
              printf ("%s\n", szBefehl);
              system (szBefehl);
            }
          } else
          {   // transcode seriell
            char szAudioFormatTranscode[12];
            char szSprachFormat[12];
            long lAudioSpur;
            // Videospur
            // Bei Faktor = 1 ohne tcrequant, Zeit ist unnoetig
            if (dFaktor > 1)
              sprintf (szBefehl, "%s -i %s -T%ld,-1 | %s -t vob -x mpeg2 | %s -f %f > %sofile.m2v", 
                                 tccat_name, dvd_device, opt_t, tcextract_name, tcrequant_name, dFaktor, szTmpDir);
            else
              sprintf (szBefehl, "%s -i %s -T%ld,-1 | %s -t vob -x mpeg2 > %sofile.m2v", 
                                 tccat_name, dvd_device, opt_t, tcextract_name, szTmpDir);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            switch (lSprachAuswahl)
            {
              case 1:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
              case 2:  lAudioSpur = lAudioTrackEnglisch; strcpy (szAudioFormat1, szAudioFormatEnglisch); break;
              case 3:  lAudioSpur = lAudioTrackDeutsch;  strcpy (szAudioFormat1, szAudioFormatDeutsch); break;
              case 4:  lAudioSpur = lZusatzAudioTrack;   strcpy (szAudioFormat1, szZusatzAudioFormat); break;
              case 5:  lAudioSpur = lAudioTrackInput1;   
                       if (!strstr (szFormatInput1, "mpeg"))
                         strcpy (szAudioFormat1, szFormatInput1); 
                       else
                         strcpy (szAudioFormat1, "mp3"); 
                       break;
            }
            // lpcm wird von Transcode als pcm gerippt
            strcpy (szAudioFormatTranscode, szAudioFormat1);
            if (strstr (szAudioFormat1, "lpcm"))
              strcpy (szAudioFormatTranscode, "pcm");
            lAudioSpur--; // tcextrcat beginnt mit Spur 0
            if (!strstr (szAudioFormatTranscode, "dts"))
            {
              sprintf (szBefehl, "%s -i %s -T%ld,-1 | %s -t vob -x %s -a %ld > %sofile.%s", 
                                 tccat_name, dvd_device, opt_t, tcextract_name, szAudioFormatTranscode, lAudioSpur, szTmpDir, szAudioFormat1);
            } else
            {
              long lTrackNr=0x88+lAudioSpur;
              sprintf (szBefehl, "%s -i %s -T%ld,-1 -P | %s /dev/stdin -dumpaudio -aid %ld -dumpfile %sofile.%s",
                                 tccat_name, dvd_device, opt_t, mplayer_name, lTrackNr, szTmpDir, szAudioFormat1);
            }
            printf ("%s\n", szBefehl);
            system (szBefehl);
            if (lSprachAuswahl == 3 || // 2. Audiospur englisch zusaetzlich rippen
                (lSprachAuswahl==5 && lAudioTrackInput2>0)
               )
            {
              if (lSprachAuswahl==3)
              {
                lAudioSpur = lAudioTrackEnglisch; 
                strcpy (szAudioFormat2, szAudioFormatEnglisch);
              } else
              {
                lAudioSpur = lAudioTrackInput2;  
                if (!strstr (szFormatInput2, "mpeg")) 
                  strcpy (szAudioFormat2, szFormatInput2);
                else
                  strcpy (szAudioFormat2, "mp3");
              }
              lAudioSpur--; // tcextrcat beginnt mit Spur 0
              // lpcm wird von Transcode als pcm gerippt
              strcpy (szAudioFormatTranscode, szAudioFormat2);
              if (strstr (szAudioFormat2, "lpcm"))
                strcpy (szAudioFormatTranscode, "pcm");
              if (!strstr (szAudioFormatTranscode, "dts"))
              {
                sprintf (szBefehl, "%s -i %s -T%ld,-1 | %s -t vob -x %s -a %ld > %sofile_2.%s", 
                                   tccat_name, dvd_device, opt_t, tcextract_name, szAudioFormatTranscode, lAudioSpur, szTmpDir, szAudioFormat2);
              } else
              {
                long lTrackNr=0x88+lAudioSpur;
                sprintf (szBefehl, "%s -i %s -T%ld,-1 -P | %s /dev/stdin -dumpaudio -aid %ld -dumpfile %sofile_2.%s",
                                   tccat_name, dvd_device, opt_t, mplayer_name, lTrackNr, szTmpDir, szAudioFormat2);
              }
              printf ("%s\n", szBefehl);
              system (szBefehl);
            }
          }
          // Wenn ohne Untertitel, dann "dvdauthor -f 'mplex |'"
          if (lUntertitel)
            sprintf (szMplexAusgabe, "%sfilm-neu.vob", szTmpDir);
          else
          {
            if (strlen (szOutputFile))
              strcpy (szMplexAusgabe, szOutputFile);
            else 
              strcpy (szMplexAusgabe, "/dev/stdout");
          }
          // Multiplexer ist auswaehlbaer
          if (lMultiplexer==1)
          {
            // 2 Audio-Spuren
            if ( (lSprachAuswahl == 3)  || // deutsch und englisch
                 (lSprachAuswahl == 5 && lAudioTrackInput2>0)
               )
            {
              sprintf (szBefehl, "%s -i %sofile.m2v -p %sofile.%s -s %sofile_2.%s -m d -o %s", 
                                 tcmplex_name, szTmpDir, szTmpDir, szAudioFormat1, szTmpDir, szAudioFormat2, szMplexAusgabe);
            } else
            {
              sprintf (szBefehl, "%s -i %sofile.m2v -p %sofile.%s -m d -o %s", 
                                 tcmplex_name, szTmpDir, szTmpDir, szAudioFormat1, szMplexAusgabe);
            }
          } else
          {
            // 2 Audio-Spuren
            if ( (lSprachAuswahl == 3)  || // deutsch und englisch
                 (lSprachAuswahl == 5 && lAudioTrackInput2>0)
               )
            {
              sprintf (szBefehl, "%s -f 8 -o %s %sofile.m2v %sofile.%s %sofile_2.%s -S 0", 
                                 mplex_name, szMplexAusgabe, szTmpDir, szTmpDir, szAudioFormat1, szTmpDir, szAudioFormat2);
            } else
            {
              sprintf (szBefehl, "%s -f 8 -o %s %sofile.m2v %sofile.%s -S 0", 
                                 mplex_name, szMplexAusgabe, szTmpDir, szTmpDir, szAudioFormat1);
            }
          }
          // Bei Untertiteln erst multiplexen
          // Untertitel mit spuunmux auslesen und mit spumux hinzufuegen
          if (lUntertitel)
          {
            printf ("%s\n", szBefehl);
            lRC=system (szBefehl);
            if (lRC==0) // mplex meldet OK, dann Loeschen
            {
              sprintf (szBefehl, "rm %sofile*", szTmpDir); // sonst erst nach dvdauthor loeschen
              printf ("%s\n", szBefehl);
              system (szBefehl);
            }
            // Untertitel auslesen
            // tccat liest DVD, 
            // spuunmux erzeugt die pngs und die xml-Datei fuer Spumux.
            sprintf (szBefehl, "%s -i %s -T%ld,-1 -P | %s -o /tmp/dvd -s %ld %s /dev/stdin",
                               tccat_name, dvd_device, (long)opt_t, spuunmux_name,
                               lUntertitel-1, szPaletteOptions); 
            printf ("%s\n", szBefehl);
            system (szBefehl);
            // Untertitel wieder ins MPEG multiplexen
            sprintf (szBefehl, "mv %sfilm-neu.vob %sdummy.mpeg", szTmpDir, szTmpDir);
            system (szBefehl);
            sprintf (szBefehl, "%s -m dvd -s 0 /tmp/dvd.xml < %sdummy.mpeg > %sfilm-neu.vob", 
                               spumux_name, szTmpDir, szTmpDir);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            // Alte Datei ohne Untertitel wieder loeschen
            sprintf (szBefehl, "rm %sdummy.mpeg", szTmpDir);
            system (szBefehl);
            // Ausserdem das XML-Script und die pngs loeschen
            system ("rm /tmp/dvd.xml");
            system ("rm /tmp/dvd*.png");
            // 2. Untertitelspur, gleicher Durchlauf
            if (lUntertitel2)
            {
              // Untertitel auslesen
              // tccat liest DVD, 
              // spuunmux erzeugt die pngs und die xml-Datei fuer Spumux.
              sprintf (szBefehl, "%s -i %s -T%ld,-1 -P | %s -o /tmp/dvd -s %ld %s /dev/stdin",
                                 tccat_name, dvd_device, (long)opt_t, spuunmux_name, 
                                 lUntertitel2-1, szPaletteOptions); 
              printf ("%s\n", szBefehl);
              system (szBefehl);
              // Untertitel wieder ins MPEG multiplexen
              sprintf (szBefehl, "mv %sfilm-neu.vob %sdummy.mpeg", szTmpDir, szTmpDir);
              system (szBefehl);
              sprintf (szBefehl, "%s -m dvd -s 1 /tmp/dvd.xml < %sdummy.mpeg > %sfilm-neu.vob", 
                                 spumux_name, szTmpDir, szTmpDir);
              printf ("%s\n", szBefehl);
              system (szBefehl);
              // Alte Datei ohne Untertitel wieder loeschen
              sprintf (szBefehl, "rm %sdummy.mpeg", szTmpDir);
              system (szBefehl);
              // Ausserdem das XML-Script und die pngs loeschen
              system ("rm /tmp/dvd.xml");
              system ("rm /tmp/dvd*.png");
            }
            sprintf (szVOBQuelle, "%sfilm-neu.vob", szTmpDir);
          } else
          {
            sprintf (szVOBQuelle, "-f ' %s |'", szBefehl);
          }
          if (strlen (szOutputFile)) // Datei statt Brennen ?
          {
            if (!lUntertitel) // mplex-Befehl ausfuehren
            {
              printf ("%s\n", szBefehl);
              system (szBefehl);
              sprintf (szBefehl, "rm %sofile*", szTmpDir); // sonst erst nach dvdauthor loeschen
              printf ("%s\n", szBefehl);
              system (szBefehl);
            } else
            {                 // Datei ist nach spumux fertig, move zu Ausgabedatei
              sprintf (szBefehl, "mv %sfilm-neu.vob %s", szTmpDir, szOutputFile);
              printf ("%s\n", szBefehl);
              system (szBefehl);
            } 
            if (lSprache == 0)
              printf ("\nFertig!\n");
            else
              printf ("\nReady!\n");
            return 0;
          }            
          if (lSprachAuswahl == 1)
          {
            sprintf (szBefehl, "%s %s %s %s -t -a %s+de -o %s %s", 
                                dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                                szAudioFormat1,
                                szFilmVerzeichnis, szVOBQuelle);
          } 
          if (lSprachAuswahl == 2)
          {
            sprintf (szBefehl, "%s %s %s %s -t -a %s+en -o %s %s", 
                               dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                               szAudioFormat1,
                               szFilmVerzeichnis, szVOBQuelle);
          }
          if (lSprachAuswahl == 3)
          {
            sprintf (szBefehl, "%s %s %s %s -t -a %s+de,%s+en -o %s %s", 
                               dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                               szAudioFormat1, szAudioFormat2,
                               szFilmVerzeichnis, szVOBQuelle);
          } 
          if (lSprachAuswahl == 4)
          {
            sprintf (szBefehl, "%s %s %s %s -t -a %s+%s -o %s %s", 
                               dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                               szAudioFormat1, szZusatzSprache, 
                               szFilmVerzeichnis, szVOBQuelle);
          }
          if (lSprachAuswahl == 5)
          {
            if (lAudioTrackInput2==0)
            {
              if (!strstr (szAudioFormat1, "mp3") && !strstr (szAudioFormat1, "lpcm")) 
                sprintf (szBefehl, "%s %s %s %s -t -a %s+%s -o %s %s", 
                                   dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                                   szAudioFormat1, szSpracheInput1,
                                   szFilmVerzeichnis, szVOBQuelle);
              else
                // Hier sind umgewandelte mpeg1 oder lpcm Streams drin, dann Audio ohne Formatangabe
                sprintf (szBefehl, "%s %s %s %s -t -a %s -o %s %s", 
                                   dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                                   szSpracheInput1,
                                   szFilmVerzeichnis, szVOBQuelle);
            } else
            {  
              if (!strstr (szAudioFormat1, "mp3") && !strstr (szAudioFormat2, "mp3") &&
                  !strstr (szAudioFormat1, "lpcm") && !strstr (szAudioFormat2, "lpcm")
                 ) 
                sprintf (szBefehl, "%s %s %s %s -t -a %s+%s,%s+%s -o %s %s", 
                                   dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                                   szAudioFormat1, szSpracheInput1,
                                   szAudioFormat2, szSpracheInput2,
                                   szFilmVerzeichnis, szVOBQuelle);
              else
                // Hier sind umgewandelte mpeg1 oder lpcm Streams drin, dann Audio ohne Formatangabe
                sprintf (szBefehl, "%s %s %s %s -t -a %s,%s -o %s %s", 
                                   dvdauthor_name, szUntertitelOptionen, szPaletteOptions, szChapterString, 
                                   szSpracheInput1,
                                   szSpracheInput2,
                                   szFilmVerzeichnis, szVOBQuelle);
            }
          }
          printf ("%s\n", szBefehl);
          lRC=system (szBefehl);
          if (lRC==0) // dvdauthor meldet OK, dann Loeschen
          {
            if (!lUntertitel) 
              sprintf (szBefehl, "rm %sofile*", szTmpDir);
            else
              sprintf (szBefehl, "rm %sfilm-neu.vob", szTmpDir);
            system (szBefehl);
          } else
          {
            if (lSprache==0)
              printf ("DVD-Author meldet Fehler, Dateien werden daher nicht geloescht!\n");
            else
              printf ("DVD-Author gives an error, so files will not be deleted!\n");
          }
        }

       
        // DVD-Author erzeugt IFOs
        if (lPackMethode != 5) // nicht bei dvdbackup
        {
          // Test, ob Unterverzeichnis "VIDEO_TS" existiert
          struct stat tmpStat;
          char filename[255];
          long lRC;
          strcpy (szVideoTS, "VIDEO_TS");
          strcpy (szAudioTS, "AUDIO_TS");
          strcpy (szVobTS, "VOB");
          strcpy (szVtsTS, "VTS");
          sprintf (filename, "%s/%s", szFilmVerzeichnis, szVideoTS);
          if (stat (filename, &tmpStat) != 0) // keine weitere Datei vorhanden
          {
            // VIDEO_TS nicht da, versuche video_ts stattdessen
            sprintf (filename, "%s/video_ts", szFilmVerzeichnis);
            if (stat (filename, &tmpStat) != 0) // keine weitere Datei vorhanden
            {
              // Auch das nicht gefunden, Hinweis
              if (lSprache == 0)
                printf ("\nVideoverzeichnis 'VIDEO_TS' nicht gefunden!\n");
              else
                printf ("\nDirectory 'VIDEO_TS' not found!\n");
            } else
            {
              // video_ts existiert, daher alles auf Kleinschrift umschalten
              strcpy (szVideoTS, "video_ts");
              strcpy (szAudioTS, "audio_ts");
              strcpy (szVobTS, "vob");
              strcpy (szVtsTS, "vts");
              if (lSprache == 0)
                printf ("\nVideoverzeichnis 'VIDEO_TS' nicht gefunden, nehme 'video_ts'!\n");
              else
                printf ("\nDirectory 'VIDEO_TS' not found, using 'video_ts'!\n");
            }
          }
          sprintf (szBefehl, "%s -T -o %s", dvdauthor_name, szFilmVerzeichnis);
          printf ("%s\n", szBefehl);
          lRC = system (szBefehl);
          if (lRC != 0)
          {
            char cNeuerVersuch;   
            if (lSprache == 0)
              printf ("'dvdauthor -T' meldet Fehler, erneute Authorisierung versuchen? (j=Ja)\n");
            else
              printf ("'dvdauthor -T' gives an error. Try a new authorisation? (y=Yes)\n");
            scanf ("%c", &cNeuerVersuch);
            if (cNeuerVersuch == 'j' || cNeuerVersuch == 'y')
            {
              char szTracks[128];
              switch (lSprachAuswahl)      
              {
                case 1:  sprintf (szTracks, "-a %s+de", szAudioFormatDeutsch); break;
                case 2:  sprintf (szTracks, "-a %s+en", szAudioFormatEnglisch); break;
                case 3:  sprintf (szTracks, "-a %s+de,%s+en", szAudioFormatDeutsch, szAudioFormatEnglisch); break;
                case 4:  sprintf (szTracks, "-a %s+%s", szZusatzAudioFormat, szZusatzSprache); break;
                case 5:  sprintf (szTracks, "-a %s+%s", szFormatInput1, szSpracheInput1);
                     if (lAudioTrackInput2 > 0)
                     {
                       strcat (szTracks, ",");
                       strcat (szTracks, szFormatInput2);
                       strcat (szTracks, "+");
                       strcat (szTracks, szSpracheInput2);
                     }
                     break;
              }
              sprintf (szBefehl, "%s -t %s %s %s %s -o %s %s/%s/*%s", 
                                 dvdauthor_name, szChapterString, szTracks, szUntertitelOptionen, szPaletteOptions,
                                 szFilmVerzeichnis, szFilmVerzeichnis, szVideoTS, szVobTS);
              printf ("%s\n", szBefehl);
              lRC = system (szBefehl);
              sprintf (szBefehl, "%s -T -o %s", dvdauthor_name, szFilmVerzeichnis);
              printf ("%s\n", szBefehl);
              lRC = system (szBefehl);
            }
            eatToNL(stdin); // Eingabepuffer leeren
          }
        }

        } // else Umschaltung auf dvdbackup


        // DVD mit dvdbackup auslesen
        // Fuer einfaches Rippen von bereits kopierten DVDs ohne 
        // dvdauthor, requant etc.
        if (lPackMethode == 5) // dvdbackup
        {
          // Wenn DVD kleiner als 4.7 GB, dann Backup ueber dvdbackup
          if (lGroesseDVDGesamt <= lGroesseDVDBytesMaximal)
          {
            if (lSprache == 0)
              printf ("DVD kleiner als 4.7 GB, Backup mit dvdbackup!\n");
            else 
              printf ("DVD <= 4.7 GB, Backup with dvdbackup!\n");
            check_program (dvdbackup_name, lSprache);
            sprintf (szBefehl, "%s -i %s -o %s -M -n%s", 
                               dvdbackup_name, dvd_device, szFilmVerzeichnis, szDVDName);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            // Fuer folgende Befehle wird das Volume-Label der DVD ans Filmverzeichnis 
            // angehaengt.
            strcpy (szAltesFilmVerzeichnis, szFilmVerzeichnis);
            if (szFilmVerzeichnis[strlen(szFilmVerzeichnis)-1] != '/')
              strcat (szFilmVerzeichnis, "/");
            strcat (szFilmVerzeichnis, szDVDName);
            // Verzeichnis AUDIO_TS anlegen
            sprintf (szBefehl, "mkdir %s/AUDIO_TS -m 0777", szFilmVerzeichnis);
            printf ("%s\n", szBefehl);
            system (szBefehl);
          } else
          {
            int titelNr, vobNr;
            char szFileName[128];
            long long lGroesseVOBs=0;
            if (lSprache == 0)
              printf ("DVD groesser als 4.7 GB, Backup mit dvdunauthor/vamps!\n");
            else 
              printf ("DVD > 4.7 GB, Backup with dvdunauthor/vamps!\n");
            check_program (dvdauthor_name, lSprache);
            check_program (dvdunauthor_name, lSprache);
            check_program (vamps_name, lSprache);
            check_program (tcprobe_name, lSprache);
            // Auslesen der DVD mit dvdunauthor
            sprintf (szBefehl, "%s %s", dvdunauthor_name, dvd_device);
            printf ("%s\n", szBefehl); 
            system (szBefehl);
            // Nun wird bestimmt, welche Dateien mit welchem Faktor verkleinert werden muessen
            for (titelNr=1; titelNr <= 99; titelNr++) 
            { 
              long long lSize;
              sprintf (szFileName, "vob_%02d_001t.vob", titelNr);
              lSize = filesize64 (szFileName);
              if (lSize == 0)
              {
                continue;
              }
              printf ("%s, %lld\n", szFileName, lSize);
              lGroesseVOBs += lSize;
              for (vobNr=2; vobNr <= 99; vobNr++)
              {
                sprintf (szFileName, "vob_%02d_%03dt.vob", titelNr, vobNr);
                lSize = filesize64 (szFileName);
                if (lSize == 0)
                {
                  break;
                }
                printf ("%s, %lld\n", szFileName, lSize);
                lGroesseVOBs += lSize;
              }
            }
            dFaktor = (double)lGroesseVOBs / (double)lGroesseDVDBytes;
            // Faktor auf Basis 4.6 GB berechnen, etwas Reserve
            if (lSprache == 0)
            {
              printf ("Groesse Titelsets: %lld Bytes\n", lGroesseVOBs);
              printf ("Faktor fuer vamps: %f\n", dFaktor);
            } else
            {
              printf ("Title-sets: %lld Bytes\n", lGroesseVOBs);
              printf ("Factor for vamps: %f\n", dFaktor);
            }
            // Nun die Dateien vampsen
            for (titelNr=1; titelNr <= 99; titelNr++) 
            { 
              long long lSize;
              for (vobNr=1; vobNr <= 99; vobNr++)
              {
                FILE *fp;
                char szTemp[] = "/tmp/vobinhalt.XXXXXX";
                char szWort[256];
                long lAnzahlAudioTracks = 0;
                long lAnzahlUntertitel = 0;
                long lVideoEnthalten = 0;
                sprintf (szFileName, "vob_%02d_%03dt.vob", titelNr, vobNr);
                lSize = filesize64 (szFileName);
                if (lSize == 0)
                {
                  break;
                }
                // Inhalt der Datei mit tcprobe bestimmen
                mkstemp(szTemp);
                sprintf (szBefehl, "%s -i %s -H 100 > %s 2>&1", tcprobe_name, szFileName, szTemp);
                printf ("%s\n", szBefehl);
                system (szBefehl);
                fp=fopen (szTemp, "r");
                while (fscanf(fp, "%s\n",szWort) != EOF)
                {
                  // Videospur enthalten ?
                  if (!lVideoEnthalten && strstr (szWort, "frame"))
                  {
                    fscanf(fp, "%s\n",szWort);
                    if (strstr (szWort, "rate:"))
                    {
                      lVideoEnthalten = 1;
                    }
                    continue;
                  }
                  // Anzahl Audiotracks
                  if (strstr (szWort, "audio"))
                  {
                    fscanf(fp, "%s\n",szWort);
                    if (strstr (szWort, "track:"))
                    {
                      lAnzahlAudioTracks++;
                    }
                    continue;
                  }
                  // Anzahl Untertitel
                  if (strstr (szWort, "detected"))
                  {
                    char szAnzahl[256];
                    fscanf(fp, "%s\n",szAnzahl);
                    fscanf(fp, "%s\n",szWort);
                    if (strstr (szWort, "subtitle(s)"))
                    {
                      szAnzahl[0] = '0';
                      szAnzahl[strlen(szAnzahl)-1] = 0;
                      lAnzahlUntertitel = atol (szAnzahl);
                    }
                    continue;
                  }
                }
                fclose (fp);
    	        unlink(szTemp);  
                if (lSprache == 0)
                  printf ("Video: %ld, Audio-Tracks: %ld, Untertitel: %ld\n",
                          lVideoEnthalten, lAnzahlAudioTracks, lAnzahlUntertitel);
                else
                  printf ("Video: %ld, Audio-Tracks: %ld, Subpictures: %ld\n",
                          lVideoEnthalten, lAnzahlAudioTracks, lAnzahlUntertitel);
                // Datei verkleinern
                if (lVideoEnthalten)
                {
                  // Kapitel auslesen
                  strcpy (szChapterString, "");
                  fp = fopen ("dvdauthor.xml", "r");
                  if (fp)
                  {
                    while (fscanf(fp, "%s\n",szWort) != EOF)
                    {
                      // Eventuell doppelt (Titleset aus mehreren Titeln)
                      if (strlen (szChapterString) && strstr (szWort, "</pgc>"))
                        break;
                      // Suche alle Stellen mit dem Dateinamen
                      if (strstr (szWort, szFileName)) // ist enthalten!
                      {
                        // Naechste Wort ist "<cell" => ueberlesen
                        fscanf(fp, "%s\n",szWort);
                        // Und dann kommt die Zeit "start="...."
                        fscanf(fp, "%s\n",szWort);
                        strncpy (szWort, &szWort[7], 11);
                        szWort[11] = 0;  
                        // Anhaengen
                        if (!strlen (szChapterString))
                          sprintf (szChapterString, "-c %s", szWort);
                        else 
                          sprintf (szChapterString, "%s,%s", szChapterString, szWort);
                      }  
                    }  
                    fclose (fp);           
                  }
                  // Verkleinern in dvdauthor eingebettet
                  if (dFaktor > 1)
                  {
                    sprintf (szBefehl, "%s -t %s -p %s -o %s -f 'cat %s | vamps -E %f ", 
                             dvdauthor_name, szChapterString, szPaletteFile, 
                             szFilmVerzeichnis, szFileName, dFaktor);
                    // Audio
                    if (lAnzahlAudioTracks)
                    {
                      for (j=1; j<=lAnzahlAudioTracks; j++)
                      {
                        if (j==1)
                          sprintf (szBefehl, "%s -a %d", szBefehl, j);
                        else
                          sprintf (szBefehl, "%s,%d", szBefehl, j);
                      }
                    }                 
                    // Untertitel
                    if (lAnzahlUntertitel)
                    {
                      for (j=1; j<=lAnzahlUntertitel; j++)
                      {
                        if (j==1)
                          sprintf (szBefehl, "%s -s %d", szBefehl, j);
                        else
                          sprintf (szBefehl, "%s,%d", szBefehl, j);
                      }
                    }   
                    sprintf (szBefehl, "%s |'", szBefehl);              
                  } else
                  {
                    // Faktor <= 1, vamps nicht noetig
                    sprintf (szBefehl, "%s -t %s -p %s -o %s %s", 
                             dvdauthor_name, szChapterString, szPaletteFile, 
                             szFilmVerzeichnis, szFileName);
                  }
                  printf ("%s\n", szBefehl);
                  system (szBefehl);
                  sprintf (szBefehl, "rm %s", szFileName);
                  printf ("%s\n", szBefehl);
                  system (szBefehl);
                }
              }
            }
            // IFOs erzeugen
            sprintf (szBefehl, "%s -T -o %s", dvdauthor_name, szFilmVerzeichnis);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            // Zuletzt alle ueberfluessigen Dateien loeschen
            sprintf (szBefehl, "rm vob_*.vob", szFileName);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            sprintf (szBefehl, "rm dvdauthor.xml");
            printf ("%s\n", szBefehl);
            system (szBefehl);
          }
        }

        // DVD auswerfen ?
        if (lEject)
        {
          sprintf (szBefehl, "%s %s", eject_name, dvd_device);
          printf ("%s\n", szBefehl); 
          system (szBefehl);
        }
 
        // Inhalt anzeigen
        if (lSprache == 0)
          printf ("\nFolgende Dateien befinden sich im Video-Verzeichnis:\n");
        else
          printf ("\nFiles in Video-Directory:\n");
        sprintf (szBefehl, "ls -C -s -h %s/%s/*", szFilmVerzeichnis, szVideoTS);
        printf ("%s\n", szBefehl); 
        system (szBefehl);

        if (calculate_filesize (szFilmVerzeichnis, szVideoTS, szVobTS, szVtsTS) >= lGroesseDVDBytesMaximal)
        {
          if (lSprache == 0)
            printf ("\nWarnung, Gesamtgroesse aller VOB-Files eventuell zu gross! Bitte kontrollieren!\n\n");
          else
            printf ("\nWarning, total size of all VOB-files possibly too big! Please check!\n\n");
        }

        // VOBS per Mplayer anzeigen zur Kontrolle
        if (strlen(szVOBPlayer) && strcmp(szVOBPlayer, "off")!=0)
        {
          char cMplayer;
          if (lSprache == 0)
            printf ("\n\nStart Anzeige per %s, bitte Enter druecken (C=Cancel):\n", szVOBPlayer);
          else
            printf ("\n\nTo start preview with %s, please press Enter (C=Cancel):\n", szVOBPlayer);
          scanf ("%c", &cMplayer);
          if (cMplayer != 'c')
          {
            check_program (szVOBPlayer, lSprache);
            sprintf (szBefehl, "%s %s/%s/*%s", szVOBPlayer, szFilmVerzeichnis, szVideoTS, szVobTS);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            if (lSprache == 0)
              printf ("\nNach Ausfuehrung %s Enter druecken...\n", szVOBPlayer);
            else
              printf ("\nAfter preview with %s please press Enter...\n", szVOBPlayer);
          }
          eatToNL(stdin); // Eingabepuffer leeren
        }

        // DVD brennen
        if (lBrennProgramm > 0)
        {
          char cBurn=' ';
          if (lWaitBurn > 0)
          {
            if (lSprache == 0)
              printf ("\n\nBitte Rohling einlegen, Enter druecken (C=Cancel):\n");
            else
              printf ("\n\nPlease insert DVD-R, then press Enter (C=Cancel):\n");
            scanf ("%c", &cBurn);
          }
          if (cBurn != 'c')
          {
            int lLaengeName;
            // RW formatieren ?
            if (lRWFormat)
            {
              if (lBrennProgramm == 1)   // Brennen mit growisofs
              {
                check_program (dvdformat_name, lSprache);
                sprintf (szBefehl, "%s -format -force %s", dvdformat_name, szDVDBrenner);
              } else                     // Brennen mit cdrecord-prodvd
              {
                check_program (cdrecord_prodvd_name, lSprache);
                sprintf (szBefehl, "%s dev=%s -format -force", cdrecord_prodvd_name, szDVDBrenner);
              }
              if (lSprache==0)
                printf ("\nBitte warten, DVD RW wird formatiert ...\n\n");
              else
                printf ("\nPlease wait, format DVD RW ...\n\n");
              printf ("%s\n", szBefehl);
              system (szBefehl);
            }
            // Titel der DVD setzen
            // DVDROM als Standard
            if (!strlen (szDVDNameOverwrite)) strcpy (szDVDNameOverwrite, szDVDName);
            if (!strlen (szDVDNameOverwrite)) strcpy (szDVDNameOverwrite, "DVD_VIDEO");
            // Blanks durch "_" ersetzen
            for (lLaengeName=0; lLaengeName <= (strlen(szDVDNameOverwrite)-1); lLaengeName++)
              if (szDVDNameOverwrite[lLaengeName] == ' ')
                szDVDNameOverwrite[lLaengeName] = '_';
            if (lBrennProgramm == 1)
            {
              char szSpeed[20];
              char szDVDCompat[20];
              // Geschwindigkeit explizit angeben?
              if (lDVDSpeed > 0)
                sprintf (szSpeed, "-speed=%ld", lDVDSpeed);
              else
                strcpy (szSpeed, "");
              // Parameter DVD-Compat?
              if (dvdcompat > 0)
                strcpy (szDVDCompat, "-dvd-compat");
              else
                strcpy (szDVDCompat, "");
              check_program (growisofs_name, lSprache);
              // Growisofs
              sprintf (szBefehl, "%s %s %s -Z %s -V %s -dvd-video %s", 
                                 growisofs_name, szSpeed, szDVDCompat,
                                 szDVDBrenner, szDVDNameOverwrite, szFilmVerzeichnis);
              while (1==1)
              {
                long lRC;
                printf ("%s\n", szBefehl);
                lRC=system (szBefehl);
                if (lRC != 0)
                {
                  char cNochmal=' ';
                  if (lSprache==0)
                    printf ("Brennen fehlgeschlagen, neuer Versuch ... (c=cancel)\n");
                  else
                    printf ("Burning failed, new try ... (c=cancel)\n");
                  scanf ("%c", &cNochmal);
                  if (cNochmal == 'c')
                  {
                    break;
                  }
                } else
                {
                  lGebrannt = 1;
                  break; // erfolgreich
                }
              }
            } else
            {
              char szSpeed[128];
              char szTemp[] = "/tmp/dvdrip.img.XXXXXX";
              check_program (mkisofs_name, lSprache);
              check_program (cdrecord_prodvd_name, lSprache);
              // Mkisofs + cdrecord-prodvd
              // Geschwindigkeit explizit angeben?
              if (lDVDSpeed > 0)
                sprintf (szSpeed, "speed=%ld", lDVDSpeed);
              else
                strcpy (szSpeed, "");
              // Key fuer volle Funktionalitaet setzen?
              if (strlen (szCDRSecurity) > 0)
                putenv (szCDRSecurity);
              if (lBrennProgramm == 2) // erst mkisofs, dann cdrecord-prodvd, aber in 2 Befehlen
              {
                mkstemp(szTemp);
                sprintf (szBefehl, "%s -dvd-video -V %s -o %s %s", 
                                   mkisofs_name, szDVDName, szTemp, szFilmVerzeichnis); 
                printf ("%s\n", szBefehl);
                system (szBefehl);
                sprintf (szBefehl, "%s -v dev=%s %s -eject %s", 
                                   cdrecord_prodvd_name, szDVDBrenner, szSpeed, szTemp);
              } else
              {                        // mkisofs | cdrecord-prodvd (on the fly)
                long lSektoren=0;
                FILE * fp;
                // Anzahl Sektoren muss bestimmt werden, ohne geht on the fly nicht
                char szImgeSizeFile[]="/tmp/imgsizeXXXXXX";
                mkstemp(szImgeSizeFile);
                sprintf (szBefehl, "%s -dvd-video -print-size %s 2>&1 | tail -n1 | sed -e 's/^.*\\ =\\ //' > %s",
                                   mkisofs_name, szFilmVerzeichnis, szImgeSizeFile);
                printf ("%s\n", szBefehl);
                system (szBefehl);
                // Anzahl Sektoren aus der Dtei auslesen
                fp=fopen(szImgeSizeFile, "r");
                fscanf (fp, "%ld\n", &lSektoren);
                fclose (fp);
                if (lSprache==0)
                  printf ("Anzahl Sektoren ISO Image On The Fly: %ld\n", lSektoren);
                else
                  printf ("No. of sectors ISO image on the fly: %ld\n", lSektoren);
                // Datei mit Anzahl Sektoren wieder loeschen
    	        unlink(szImgeSizeFile);  
                // Brennbefehl zusammemsetzen
                sprintf (szBefehl, "%s -dvd-video -V %s %s | %s -v dev=%s %s -eject -dao tsize=%lds -",
                                   mkisofs_name, szDVDName, szFilmVerzeichnis, 
                                   cdrecord_prodvd_name, szDVDBrenner, szSpeed, lSektoren);

              }
              while (1==1)
              {
                long lRC;
                printf ("%s\n", szBefehl);
                lRC=system (szBefehl);
                if (lRC != 0)
                {
                  char cNochmal=' ';
                  if (lSprache==0)
                    printf ("Brennen fehlgeschlagen, neuer Versuch ... (c=cancel)\n");
                  else
                    printf ("Burning failed, new try ... (c=cancel)\n");
                  scanf ("%c", &cNochmal);
                  if (cNochmal == 'c')
                  {
                    break;
                  }
                } else
                {
                  lGebrannt = 1;
                  break; // erfolgteich
                }
              }
              // Datei wieder loeschen
              if (lBrennProgramm == 2) // nicht noetig bei "on the fly"
              {
                sprintf (szBefehl, "rm %s", szTemp);
                printf ("%s\n", szBefehl);
                system (szBefehl);
              }
            }
          }
        }

        // Dateien sollten nicht geloescht werden, wenn Fehlermeldungen beim Brennen
        if (lLoeschen > 0 && lGebrannt == 0)
        {
          if (lSprache==0)
            printf ("\nDateien werden nicht geloescht, weil nicht gebrannt!\n");
          else
            printf ("\nNot deleting files, because burning failed!\n");
          lLoeschen = 0;
        }

        // Filmverzeichnis entsorgen
        if (lLoeschen>0)
        {
          if (lSprache == 0)
            printf ("\n\nBitte warten, Files loeschen!\n\n");
          else
            printf ("\n\nPlease wait, deleting all temporary files!\n\n");
          if (szFilmVerzeichnis[strlen(szFilmVerzeichnis)-1] != '/')
            strcat (szFilmVerzeichnis, "/");
          sprintf (szBefehl, "rmdir %s%s", szFilmVerzeichnis, szAudioTS);
          printf ("%s\n", szBefehl);
          system (szBefehl);
          sprintf (szBefehl, "rm %s%s/*", szFilmVerzeichnis, szVideoTS);
          printf ("%s\n", szBefehl);
          system (szBefehl);
          sprintf (szBefehl, "rmdir %s%s", szFilmVerzeichnis, szVideoTS);
          printf ("%s\n", szBefehl);
          system (szBefehl);
          // bei dvdbackup zusaetzlich das Unterverzeichnis loeschen laut DVD Volume
          // und dann vorheriges Verzeichnis wieder einstellen.
          if (lPackMethode == 5 && lGroesseDVDGesamt <= lGroesseDVDBytesMaximal)
          {
            sprintf (szBefehl, "rmdir %s", szFilmVerzeichnis);
            printf ("%s\n", szBefehl);
            system (szBefehl);
            strcpy (szFilmVerzeichnis, szAltesFilmVerzeichnis);
            if (szFilmVerzeichnis[strlen(szFilmVerzeichnis)-1] != '/')
              strcat (szFilmVerzeichnis, "/");
          }
          // Jetzt das Basisverzeichnis loeschen
          // Zuerst das angehaengte "/" loeschen
          szFilmVerzeichnis[strlen(szFilmVerzeichnis)-1] = 0;
          // Nicht aus Versehen ein Systemverzeichnis loeschen
          if (strcmp (szFilmVerzeichnis, "/bin") != 0 &&
              strcmp (szFilmVerzeichnis, "/boot") != 0 &&
              strcmp (szFilmVerzeichnis, "/dev") != 0 &&
              strcmp (szFilmVerzeichnis, "/etc") != 0 &&
              strcmp (szFilmVerzeichnis, "/home") != 0 &&
              strcmp (szFilmVerzeichnis, "/initrd") != 0 &&
              strcmp (szFilmVerzeichnis, "/lib") != 0 &&
              strcmp (szFilmVerzeichnis, "/misc") != 0 &&
              strcmp (szFilmVerzeichnis, "/mnt") != 0 &&
              strcmp (szFilmVerzeichnis, "/opt") != 0 &&
              strcmp (szFilmVerzeichnis, "/proc") != 0 &&
              strcmp (szFilmVerzeichnis, "/root") != 0 &&
              strcmp (szFilmVerzeichnis, "/sbin") != 0 &&
              strcmp (szFilmVerzeichnis, "/tmp") != 0 &&
              strcmp (szFilmVerzeichnis, "/usr") != 0 &&
              strcmp (szFilmVerzeichnis, "/var") != 0
             )
          {
            sprintf (szBefehl, "rmdir %s", szFilmVerzeichnis);
            printf ("%s\n", szBefehl);
            system (szBefehl);
          }
        }
 
        // Datei mit Palette wieder loeschen
        if (lPaletteVorhanden == 1)
        {
          unlink(szPaletteFile);
        }

        if (lSprache == 0)
          printf ("\n\nFertig! Viel Spass beim Anschauen der Sicherheitskopie!\n\n");
        else
          printf ("\n\nReady!\n\n");
	STOP;
	return 0;
}
